/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| BDDE.C          |Module| N/A             |Library| N/A             |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Turbo C V2.0 version 1.0a                        | HanSoft          |231191|
| Bull DPX/2 340 version 1.0a                      | HanSoft          |241191|
| Coherent V4.2 version 1.4a                       | HanSoft          |020394|
| Linux V2.2.14 version 1.7e                       | HanSoft          |060602|
| LCC V3.3 version 1.7e                            | HanSoft          |070602|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Helpscreen changed; some other minor changes     | HanSoft          |261191|
| Minor bug: BDDE reports "too many files"-error   | HanSoft          |301191|
| Added automatic interleave support and -i option | HanSoft          |170692|
| Added 7:1 interleave and -i range check          | HanSoft          |180692|
| Added experimental Atari ST simulator support    | HanSoft          |250892|
| Fixed "NONAME" bug in GetName()                  | HanSoft          |250892|
| Fixed UNKNOWN bug in GetAType() and MakeTapeHd() | HanSoft          |260892|
| Removed buffers from DEMO-version                | HanSoft          |270892|
| Changed basename() to library-version            | HanSoft          |070992|
| Headername and filename synchronized with -H2    | HanSoft          |070992|
| BDDE now always writes lowercase filenames       | HanSoft          |070992|
| "No target-directory/noname" bug fixed           | HanSoft          |070992|
| Changed -Hx to -Cx and HeaderType to ConverType  | HanSoft          |150992|
| Changed standard interleave to 1:1               | HanSoft          |150992|
| Changed DEBUG msg to INFO msg in GetAType()      | HanSoft          |150992|
| Added CEXT #define support                       | HanSoft          |230992|
| Added lots of #defines to please Nick Keeman     | HanSoft          |101092|
| Changed GetName() and PatchName() to simplify    |                  |      |
| adding support for other emulators               | HanSoft          |121092|
| Added support for SpecEm emulator                | HanSoft          |121092|
| Added support autoRUN linenumber listing         | HanSoft          |121092|
| Changed MakeEntry() to check #sectors            | HanSoft          |121092|
| Added GetFType(), changed MakeRS232Hd()          | HanSoft          |171092|
| Changed MakeTapeHd, GetName() and CopyFile()     | HanSoft          |171092|
| Removed silly bug in call to GetFType()          | HanSoft          |201092|
| Cleaned up the code a little                     | HanSoft          |221092|
| Fixed several bugs in PatchName()                | HanSoft          |261092|
| Changed RunLine() to display BetaDisk-name       | HanSoft          |261092|
| Fixed bug in GetName() concerning SpecEm         | HanSoft          |261092|
| Added interleaves 2:1, 4:1, 6:1 and 8:1          | HanSoft          |140993|
| Added WriteBlock() and CHECK() macro             | HanSoft          |140993|
| Added MakeFlag() and .TAP support                | HanSoft          |150993|
| Fixed BASIC allocation error (corrupted .TAP)    | HanSoft          |150993|
| Added CheckLength(); restructured RunLine()      | HanSoft          |160993|
| Added ANSI_C support                             | HanSoft          |020394|
| Added ShowSettings(), PrintArgs()                | HanSoft          |160594|
| Added GetIniOptions(), GetAllOptions()           | HanSoft          |160594|
| Added UnMountDisk(), GetCommand()                | HanSoft          |160594|
| Changed GetOpts() to GetOptions()                | HanSoft          |160594|
| Changed various variables and #defines           | HanSoft          |170594|
| Changed -? to -v, added -?, -I, and -V           | HanSoft          |180594|
| Added -l option                                  | HanSoft          |190594|
| Added -M option and CheckHeader()                | HanSoft          |200594|
| Added -T option, MNOBDISK msg, and CheckList()   | HanSoft          |250594|
| Added -F option, MNO_TDIR msg, removed -T option | HanSoft          |300594|
| Changed program syntax drastically               | HanSoft          |300594|
| Changed -v to -V and -V to -v                    | HanSoft          |030694|
| Added coreleft() to MS-DOS ShowSettings()        | HanSoft          |030694|
| Added GetListFile() and listfile functionality   | HanSoft          |030694|
| Fixed bug concerning raw dumps and SmartSeek     | HanSoft          |030694|
| Made listfile option only for registered users   | HanSoft          |050694|
| Fixed stupid bug in GetOptions() (forgot break;) | HanSoft          |060694|
| Fixed stupid bug in getting default bdde.ini     | HanSoft          |020794|
| Fixed typo in #dfHdr                             | HanSoft          |070794|
| Added GetFileList(), MakeCalc(), added 'dc'      | HanSoft          |120994|
| Changed error messages, main(), GetAllOptions()  | HanSoft          |120994|
| Changed ErrMsg(), Execute()                      | HanSoft          |120994|
| Added -S- option, changed GetCommand()           | HanSoft          |130994|
| Changed GetFileList(), CheckList(), UnMountDisk()| HanSoft          |140994|
| Added wildcard-support, -l-, -u-, -s-, -f-, -c-  | HanSoft          |140994|
| Fixed tiny bug in GetAllOptions()                | HanSoft          |140994|
| Fixed bug in GetName() when using Z80 V2.x       | HanSoft          |140994|
| Cleaned up code a little                         | HanSoft          |160994|
| Added ExecShell(), ExecCommand(), BddeShell()    | HanSoft          |190994|
| Added CleanUp(); changed ErrMsg(), Help()        | HanSoft          |190994|
| Changed Execute(), MountDisk(), UnMountDisk()    | HanSoft          |190994|
| Changed GetOptions()                             | HanSoft          |190994|
| Fixed bug in ExecCommand() and MakeCalc()        | HanSoft          |200994|
| Added MS-Windows support                         | HanSoft          |200994|
| Added 'sleep' and 'zx' commands and -E option    | HanSoft          |210994|
| Added screens appropriate for target OS          | HanSoft          |220994|
| Added 'guide' command to MSDOS version           | HanSoft          |230994|
| Fixed bug in CheckList() for left wildcard       | HanSoft          |230994|
| Fixed bug in GetAllOptions() concering 'guide'   | HanSoft          |250994|
| Fixed bug in ExecCommand() in PatchPos           | HanSoft          |260994|
| Fixed bug in GetAllOptions() concerning BDDE-dir | HanSoft          |260994|
| Added ExecMount(); removed Argn in ExecCommand() | HanSoft          |260994|
| Fixed bug in GetOptions() -v switch during 'sh'  | HanSoft          |061094|
| Changed MakeCalc() due to strcalc() change       | HanSoft          |220895|
| Changed stpncpy() to strncopy() (Linux compat.)  | HanSoft          |090497|
| Removed easyc.h, added hansoft.h, ReadLine()     | HanSoft          |060602|
| Added several _WIN32 directives                  | HanSoft          |060602|
| Made some fixes for Win32 LCC compiler           | HanSoft          |060602|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| DEMO has restricted functionality and speed      | HanSoft          |221191|
| MS-Windows: no 'sleep' or '!' shell-commands     | HanSoft          |210994|
| MS-Windows/Unix: no 'guide' or 'zx' commands     | HanSoft          |230994|
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include <ctype.h>

#ifdef __TURBOC__
#include <io.h>
#include <dir.h>
#include <dos.h>
#include <alloc.h>
#else
#include <unistd.h>
#endif

#include <setjmp.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#ifdef HANSOFT
#include "hansoft.h"
#else
#include "bddelib.h"
#endif
#include "version.c"

#if !defined(UNIX) && !defined(_Windows) && !defined(_WIN32)
#define DRDOS
#endif

#define odHex "\
%3u (%02Xh)     %02x %02x %02x %02x - %02x %02x %02x %02x \
- %02x %02x %02x %02x - %02x %02x %02x %02x\n"

#define lsHdr "\n\
                Addr    Len     B/D  First     First  Last        First  Last\n\
Filename  Type  Len(B)  Run(C)  NEG  Tk/Sd/Sc  Abs.S  Abs.S  #Sc  Tk/Sc  Tk/Sc\n\
=============================================================================="

#define lsFmt "\
%-8s  %-5s  %5u   %5u  %3u   %2u/%1u/%02u   %4u   %4u  %3u %3u/%02u %3u/%02u\n"

#define dfHdr "\n\
PHYSICAL DISK INFORMATION                 LOGICAL DISK INFORMATION\n\
-------------------------                 ------------------------"

#define dfBdy "\
Starting head..................   0       First sector of directory.......    0\n\
Starting cylinder..............   0       Number of sectors on directory..   16\n\
Starting sector................   1       Maximum number of dir. entries..  128"


#ifdef DRDOS

#define BDDEMAN "bdde-man.exe"

#define  SettingsFormat "(%s) %s: %s settings %s;\n\
uchar    O_odTrk             = %u\n\
char     O_DbgLvl            = %u\n\
char     O_DataType          = %u\n\
char     O_ConverType        = %u\n\
char     O_MediaType         = %u\n\
char     O_InterLeave        = %u\n\
char     O_DataChar          = %c\n\
char     O_BetaDump [64]     = %s\n\
char     O_Spectrum [64]     = %s\n\
char     O_Prompt   [16]     = %s\n\
char     _LNG_               = %s\n\
char     _FSL_               = %s\n\
char     _SEF_               = %s\n\
char     _FDC_               = %s\n\
char     _SMS_               = %s\n\
char     _ASC_               = %s\n"

#define HelpText "\n\
BetaDisk Dump Extractor V1.7e - (c) 1991,2002  HanSoft & Partners\n\
\n\
   Usage: BDDE <command> [options] [<filelist|@listfile> <directory>]\n\
\n\
Commands: ls, df, di, cp, od, dc, sh\n\
Options : -D%u    (Set debug level to %u; all)\n\
          -i%u    (Set interleave to %u; all)\n\
          -M%u    (Use mediatype %u; all)\n\
          -F%s    (Mount BetaDisk dumpfile %s; all)\n\
          -I%s    (Initialize using init-file %s; all)\n\
          -l[-]   ([Do not] show a long directory listing; ls)\n\
          -u[-]   ([Do not] use erased files too; cp, ls)\n\
          -s[-]   ([Do not] force sector filesize on error; cp)\n\
          -C%u    (Use conversion method %u; cp)\n\
          -d%c    (Set first array to variable %c; cp)\n\
          -f[-]   ([Do not] use same variable for all arrays; cp)\n\
          -#      (Force numeric arrays; cp)\n\
          -$      (Force character arrays; cp)\n\
          -S[-]   ([Do not] use random seek; cp, od)\n\
          -t%u    (Dump track %u; od)\n\
          -c[-]   ([Do not] dump track in ascii; od)\n\
          -E%s    (Use %s to start Spectrum Emulator; sh)\n\
          -p%s    (Use %s as prompt; sh)"

#define ManScreen "\
ls\t[options] [filelist]\t\t\tList files\n\
cp\t[options] <filelist> <directory>\tCopy files\n\
df\t[options]\t\t\t\tShow free diskspace\n\
di\t[options]\t\t\t\tShow disk characteristics\n\
od\t[options]\t\t\t\tDump a track\n\
dc\t[options]\t\t\t\tDesk Calculator\n\
mount\t[options]\t\t\t\tMount a BetaDisk\n\
!\t[command]\t\t\t\tExecute external command\n\
echo\t[string]\t\t\t\tShow string\n\
#\t[string]\t\t\t\tComment line\n\
sleep\t<seconds>\t\t\t\tPause execution\n\
cd\t<directory>\t\t\t\tChange directory\n\
exit\t\t\t\t\t\tExit shell\n\
zx\t\t\t\t\t\tStart Spectrum Emulator\n\
guide\t\t\t\t\t\tStart BDDE User Guide\n\
help\t\t\t\t\t\tShow standard BDDE helpscreen\n\
man\t\t\t\t\t\tShow this screen\n\
env\t\t\t\t\t\tShow BDDE variables\n\
pwd\t\t\t\t\t\tShow present working directory\n"

#else

#define  SettingsFormat "(%s) %s: %s settings %s;\n\
uchar    O_odTrk             = %u\n\
char     O_DbgLvl            = %u\n\
char     O_DataType          = %u\n\
char     O_ConverType        = %u\n\
char     O_MediaType         = %u\n\
char     O_InterLeave        = %u\n\
char     O_DataChar          = %c\n\
char     O_BetaDump [64]     = %s\n\
char     O_Prompt   [16]     = %s\n\
char     _LNG_               = %s\n\
char     _FSL_               = %s\n\
char     _SEF_               = %s\n\
char     _FDC_               = %s\n\
char     _SMS_               = %s\n\
char     _ASC_               = %s\n"

#define HelpText "\n\
BetaDisk Dump Extractor V1.7e - (c) 1991,2002  HanSoft & Partners\n\
\n\
   Usage: BDDE <command> [options] [<filelist|@listfile> <directory>]\n\
\n\
Commands: ls, df, di, cp, od, dc, sh\n\
Options : -D%u    (Set debug level to %u; all)\n\
          -i%u    (Set interleave to %u; all)\n\
          -M%u    (Use mediatype %u; all)\n\
          -F%s    (Mount BetaDisk dumpfile %s; all)\n\
          -I%s    (Initialize using init-file %s; all)\n\
          -l[-]   ([Do not] show a long directory listing; ls)\n\
          -u[-]   ([Do not] use erased files too; cp, ls)\n\
          -s[-]   ([Do not] force sector filesize on error; cp)\n\
          -C%u    (Use conversion method %u; cp)\n\
          -d%c    (Set first array to variable %c; cp)\n\
          -f[-]   ([Do not] use same variable for all arrays; cp)\n\
          -#      (Force numeric arrays; cp)\n\
          -$      (Force character arrays; cp)\n\
          -S[-]   ([Do not] use random seek; cp, od)\n\
          -t%u    (Dump track %u; od)\n\
          -c[-]   ([Do not] dump track in ascii; od)\n\
          -p%s    (Use %s as prompt; sh)"

#ifdef UNIX

#define ManScreen "\
ls\t[options] [filelist]\t\t\tList files\n\
cp\t[options] <filelist> <directory>\tCopy files\n\
df\t[options]\t\t\t\tShow free diskspace\n\
di\t[options]\t\t\t\tShow disk characteristics\n\
od\t[options]\t\t\t\tDump a track\n\
dc\t[options]\t\t\t\tDesk Calculator\n\
mount\t[options]\t\t\t\tMount a BetaDisk\n\
echo\t[string]\t\t\t\tShow string\n\
#\t[string]\t\t\t\tComment line\n\
!\t<command>\t\t\t\tExecute external command\n\
sleep\t<seconds>\t\t\t\tPause execution\n\
cd\t<directory>\t\t\t\tChange directory\n\
exit\t\t\t\t\t\tExit shell\n\
help\t\t\t\t\t\tShow standard BDDE helpscreen\n\
man\t\t\t\t\t\tShow this screen\n\
env\t\t\t\t\t\tShow BDDE variables\n\
pwd\t\t\t\t\t\tShow present working directory\n"

#else

#define ManScreen "\
ls\t[options] [filelist]\t\t\tList files\n\
cp\t[options] <filelist> <directory>\tCopy files\n\
df\t[options]\t\t\t\tShow free diskspace\n\
di\t[options]\t\t\t\tShow disk characteristics\n\
od\t[options]\t\t\t\tDump a track\n\
dc\t[options]\t\t\t\tDesk Calculator\n\
mount\t[options]\t\t\t\tMount a BetaDisk\n\
echo\t[string]\t\t\t\tShow string\n\
#\t[string]\t\t\t\tComment line\n\
cd\t<directory>\t\t\t\tChange directory\n\
exit\t\t\t\t\t\tExit shell\n\
help\t\t\t\t\t\tShow standard BDDE helpscreen\n\
man\t\t\t\t\t\tShow this screen\n\
env\t\t\t\t\t\tShow BDDE variables\n\
pwd\t\t\t\t\t\tShow present working directory\n"
#endif
#endif


#ifdef UNIX
#define IniFile ".bdderc"
#define DeLims "\n\x4"
#else
#define IniFile "bdde.ini"
#define DeLims "\r\n\x1a"
#endif

#define FATAL 5          /*  Fatal errors                               */
#define ERROR 4          /*  Errors                                     */
#define WARN  3          /*  Warnings                                   */
#define INFO  2          /*  General information (verbose)              */
#define FLOW  1          /*  General flow of program                    */
#define DEBUG 0          /*  Debug information about processing Trk/Sc  */

#define LS 0             /* Show Directory  */
#define DF 1             /* Show Volume information */
#define DI 2             /* Show Technical Disk information */
#define CP 3             /* Copy files to DOS or Unix */
#define OD 4             /* Dump a track in hex or ascii */
#define DC 5             /* Use a simple desk calculator */
#define SH 6             /* Execute the shell */

#define BASIC   0        /* BASIC program */
#define NUMBER  1        /* Number array */
#define STRING  2        /* String array */
#define UNKNOWN 3        /* Unknown array type */
#define CODE    3        /* Machinecode */

#define RAWDUMP 0        /* Raw dump without any headers */
#define ANADUMP 1        /* Classical Anadisk dump */

#define NONE    0        /* No header */
#define LUNTER  1        /* RS232 header; DOS conversion */
#define GANDLER 2        /* Tape header; Atari conversion */
#define PHAIR   3        /* Tape header; DOS conversion */
#define Z80V2   4        /* Tape header; DOS conversion */

#define BFSCFREE  225    /* First sector free on disk */
#define BFTKFREE  226    /* First track free on disk */
#define BDISKTYP  227    /* Diskette type */
#define BNOFILES  228    /* Total number of files */
#define BLSBFREE  229    /* Free room, least significant byte */
#define BMSBFREE  230    /* Free room, most significant byte */
#define BPASSWRD  234    /* Offset to password */
#define BDELFILE  244    /* Number of deleted files */
#define BDISKNAM  245    /* Offset to diskname */

#define FBETFNAM  0      /* Offset to filename */
#define FFILTYPE  8      /* File type */
#define FLSBADDR  9      /* Least significant byte of address */
#define FMSBADDR 10      /* Most significant type of address */
#define FLSB_LEN 11      /* Least significant byte of length */
#define FMSB_LEN 12      /* Most significant byte of length */
#define FNO_SECT 13      /* Total number of sectors */
#define FFIRSTSC 14      /* Fist sector of file */
#define FFIRSTTK 15      /* First track of file */

#define SFILETYP  0      /* Serial header filetype */
#define SLSB_LEN  1      /* Serial header least significant byte of length */
#define SMSB_LEN  2      /* Serial header most significant byte of length */
#define SLSB_ADR  3      /* Serial header least significant byte of address */
#define SMSB_ADR  4      /* Serial header most significant byte of address */
#define SARRAYCH  5      /* Serial header character of array variable */
#define SLSB_BLN  5      /* Serial header lsb of BASIC length */
#define SMSB_BLN  6      /* Serial header msb of BASIC length */

#define TFILETYP  0      /* Tape header filetype */
#define THEADNAM  1      /* Offset to tape header name */
#define TLSB_LEN 11      /* Tape header least significant byte of length */
#define TMSB_LEN 12      /* Tape header most significant byte of length */
#define TLSB_ADR 13      /* Tape header least significant byte of address */
#define TMSB_ADR 14      /* Tape header most significant byte of address */
#define TLSB_RUN 13      /* Tape header least significant byte of runline */
#define TMSB_RUN 14      /* Tape header most significant byte of runline */
#define TARRAYCH 14      /* Tape header character of array variable */
#define TLSB_BLN 15      /* Tape header lsb of BASIC length */
#define TMSB_BLN 16      /* Tape header msb of BASIC length */

#define HLEN_LSB 0       /* Flag lsb of length block */
#define HLEN_MSB 1       /* Flag msb of length block */
#define HBLK_TYP 2       /* Flag type of block */

#define MEOFDMP   0      /* EOF found on dumpfile */
#define MNODREAD  1      /* Unable to read dumpfile */
#define MINVHEAD  2      /* Invalid header */
#define MEXPTSS   3      /* Expected Tk/Sd/Sc */
#define MBFSKIP   4      /* Betafile skipped */
#define MBMOREF   5      /* BetaDisk contains more files */
#define MNOTYPE   6      /* Unknown type found */
#define MFSDIFF   7      /* Filesize differs */
#define MFSADJ    8      /* Filesize adjusted */
#define MERAFIND  9      /* Erased file found */
#define MNOMOUNT 10      /* Unable to mount dumpfile */
#define MILLOPT  11      /* Illegal option */
#define MERRFILE 12      /* Error on file I/O */
#define MNOTRACK 13      /* No such track */
#define MCPBFILE 14      /* Betafile copied */
#define MNOFOPEN 15      /* Unable to open file */
#define MNOBUFF  16      /* Unable to allocate buffer */
#define MNOFWRIT 17      /* Unable to write to file */
#define MBYTWRIT 18      /* Bytes written to file */
#define MARRAYTP 19      /* Array type found */
#define MWRITCOD 20      /* File written as CODE */
#define MNOACCES 21      /* Unable to access track */
#define MINVTRK  22      /* Invalid track read */
#define MINTADJ  23      /* Interleave adjusted */
#define MNORUNLN 24      /* Unable to determine linenumber */
#define MRUNLINE 25      /* Program runs from line */
#define MRENAMEF 26      /* Please rename file */
#define MSNAPSHT 27      /* Probable snapshot file */
#define MCHKSUM  28      /* Checksum calculated */
#define MTOOLONG 29      /* Option too long */
#define MNOHOME  30      /* Home-directory not defined */
#define MHPALLOC 31      /* Memory allocated on heap */
#define MHPFREED 32      /* Memory freed on heap */
#define MCURSETS 33      /* Current settings */
#define MARGUMEN 34      /* Arguments */
#define MDATFERR 35      /* Datafile error */
#define MNOTHERE 36      /* File not found */
#define MNOBDISK 37      /* Not a BetaDisk */
#define MNO_TDIR 38      /* Not a target directory */
#define MHPNOMEM 39      /* Cannot allocate memory on heap */
#define MNOCOMMD 40      /* No such command in shell */
#define MEXIT_SH 41      /* Exiting shell */

#define BOOTOFFS 2048    /* Offset to boot sector information */
#define BYTE_ANA 4224    /* Size of an Anadisk raw track (with sector-ID) */
#define BYTE_TRK 4096    /* Size of a single track */
#define BYTE_SEC  256    /* Size of a sector */
#define SECT_TRK   16    /* No. of sectors per track */
#define SECT_DIR   16    /* No. of sectors in directory */
#define RUNSLACK    4    /* Minimum slack that can hold autorun linenumber */

#define FILESPEC  0      /* `cp` and `ls use file specification */
#define WILDCARD  1      /* `cp` and `ls use wildcard specification */
#define LISTFILE  2      /* `cp` and `ls use listfile specification */

#define NAME   0         /* Not a wildcard, but a name */
#define LEFT   1         /* Wildcard left */
#define RIGHT  2         /* Wildcard right */
#define BOTH   3         /* Wildcard on both sides */

#define HEAD_BLK  '\x0'  /* Signal headerblock */
#define DATA_BLK  '\xff' /* Signal datablock */

#define SRCBUF  BYTE_ANA /* Size source buffer; must be the largest */

#ifndef __TINY__
#define TGTBUF  16384    /* Size target buffer on larger models */
#else
#define TGTBUF   4096    /* Size target buffer on tiny model */
#endif

#define ERRSTAT  (EStat[ErrLvl])

#define LSB(a) (unsigned char) ((a) & 255)
#define MSB(b) (unsigned char) ((b) >> 8)
#define CHECK(a) ((ErrLvl=a)>=O_DbgLvl)
#define TOBOOL(a) (a?"TRUE":"FALSE")

typedef struct
{
  char Filename [9];                   /* BetaDisk filename */
  unsigned char Type;                  /* BASIC, CODE or DATA */
  unsigned char FLtk;                  /* File starts at track */
  unsigned char FLsc;                  /* File starts at sector */
  unsigned char LLtk;                  /* File ends at track */
  unsigned char LLsc;                  /* File ends at sector */
  unsigned char NEG;                   /* 256 - # bytes last sector */
  unsigned int  Address;               /* Load file at address */
  unsigned int  Length;                /* BASIC program length */
  unsigned int  TotLen;                /* Total Length */
} DirEntry;

DirEntry Dirty [128];                  /* Beta Disk Dump Directory */

jmp_buf ShellErr;                      /* Buffer for shell error-return */

static char *EStat [] =                /* Status of error */
{
    "DEBUG",
    "FLOW ",
    "INFO ",
    "WARN ",
    "ERROR",
    "FATAL"
};

unsigned char TrkBuf [BYTE_TRK];       /* Track Buffer */
#ifndef DEMO
char InpBuf [SRCBUF];                  /* Input File Buffer */
char OutBuf [TGTBUF];                  /* Output File Buffer */
#endif
char LineBuf [256];                    /* LineBuffer */
unsigned char Dp;                      /* Last free Directory Entry */
unsigned char BDp;                     /* No. files reported by BetaDisk */
unsigned char ChkSum;                  /* Checksum for Z80 V2 .TAP files */
unsigned Fatals;                       /* Fatal errors during Shell */

char  *BetaDump;                       /* Basename Dumpfile */
char **FileList = NULL;                /* Pointer to the filelist */
char **PendCall;                       /* Internal call interface */
FILE  *BetaDumpFp;                     /* Filepointer Dumpfile */
FILE  *DOSFp;                          /* Filepointer DOS file */
char  DOSFname [64];                   /* DOS filename */
char  TgtDir   [64];                   /* Target directory */
#ifdef DRDOS
char  BddeManPath [64];                /* Path where bdde-man.exe is located */
#endif
char  Headname [9];                    /* Name in tape header */
char  ErrLvl;                          /* Level error found */

unsigned char Header [17];             /* Tape- and serial header */
unsigned char Ftk;                     /* Current Fysical Track */
unsigned char Fsd;                     /* Current Fysical Side */
unsigned char Ltk;                     /* Current Logical Track */
unsigned int  Asc;                     /* Current Absolute Sector */
unsigned char DSd;                     /* Double Sided or Single Sided */
unsigned char Tracks;                  /* No. Tracks */
unsigned int  TrackSize;               /* Size of a track */

char _FSL_ = FALSE;                    /* Calc. filelength from no. sect. */
char _SEF_ = FALSE;                    /* Extract deleted files too? */
char _FDC_ = FALSE;                    /* Use different variablenames? */
char _SMS_ = FALSE;                    /* No fseek() reading tracks */
char _ASC_ = FALSE;                    /* `od` dumps hex */
char _LNG_ = FALSE;                    /* Show a long directory listing */
char _FFL_ = FALSE;                    /* Free filelist on exit */
char _FIL_ = FALSE;                    /* Standard intelligent interleave */
char _TF2_ = FALSE;                    /* Uses Z80 V2-like tape format? */
char _CAL_ = TRUE;                     /* BDDE command called from cmd line */
char _BFO_ = FALSE;                    /* BetaDisk file is closed */
char _FPC_ = FALSE;                    /* No call pending */

char O_BetaDump [64] = "";             /* Fullname BetaDisk dump */
#ifdef DRDOS
char O_Spectrum [64] = "z80";          /* Command to start Spectrum Emul */
#endif
char O_Prompt   [16] = "$ ";           /* Use '$ ' as default shell prompt */
char O_DbgLvl        = INFO;           /* Below this level no messages */
char O_DataType      = UNKNOWN;        /* Standard Type of DATA-files */
char O_ConverType    = LUNTER;         /* Standard write a RS232 header */
char O_MediaType     = ANADUMP;        /* Standard media is an Anadisk dump */
char O_InterLeave    = 0;              /* Standard interleave is 1 */
char O_DataChar      = 'A';            /* Nest variable for DATA */

unsigned char O_odTrk = 0;             /* `od` dumps track no. */


void GetOptions __PROTO((char **args));
void CleanUp __PROTO((void));          /* function prototypes */
void BddeShell __PROTO((void));


/*
This function works just like chdir, but when a drive is specified it
makes that drive default. TurboC only.
*/

#ifdef __TURBOC__
  int _chdir (char *path)
{
  if (path [1] == ':') setdisk (toupper ((int) path [0]) - (int) 'A');
  return (chdir (path));
}
#endif


/*
The LCC compiler doesn't seem to provide these prototypes :-(
*/

#ifdef __LCC__
int _chdir(const char *dirname);
char *getcwd(char *buffer,int maxlen);
#endif


/*
This routine reads a line of input from stdin. Used by the shell.
*/

#ifndef ARCHAIC
  char* ReadLine (void)
#else
  char* ReadLine ()
#endif

{
  fgets (LineBuf, sizeof(LineBuf), stdin);
  LineBuf [strlen (LineBuf) - 1] = '\0';
  return (Strtrm (LineBuf));
}

/*
This routine is the main engine behind all error message handling. If an error
is fatal it aborts. If the user defined ERROR as the debug level it also aborts
when finding a ERROR warning.
*/

#ifndef ARCHAIC
  void ErrMsg (int MsgNo, ...)
#else
  void ErrMsg (MsgNo) int MsgNo;
#endif

{
  static char *EMsg [] =
  {
    "(%s) %s: Unexpected end of file \'%s\'\n",                    /* Msg 0 */
    "(%s) %s: Unknown error reading file \'%s\'\n",
    "(%s) %s: Invalid sector header: %s (%02Xh)/%s (%02Xh)\n",
    "(%s) %s: Expected Tk%u/Sd%u/Sc%u; read Tk%u/Sd%u/Sc%u in buffer at offset %04Xh\n",
    "(%s) %s: BetaDisk file \'%s\' skipped\n",                     /* Msg 4 */
    "(%s) %s: BetaDisk reported %s files than BDDE found (%u vs. %u)\n",
    "(%s) %s: Unknown type \'%c\' in file \'%s\'; CODE assumed\n", /* Msg 6 */
    "(%s) %s: File \'%s\' needs %u sectors but allocates %u sectors\n",
    "(%s) %s: Filesize adjusted; \'%s\' now %u bytes long\n",
    "(%s) %s: Erased file \'?%s\' found: skipped\n",               /* Msg 9 */
    "(%s) %s: Unable to mount file \'%s\'\n",
    "(%s) %s: Illegal option \'-%c\' ignored\n",
    "(%s) %s: Error %sing file \'%s\'\n",                          /* Msg 12 */
    "(%s) %s: Track %u does not exist; disk has only %u tracks\n",
    "(%s) %s: BetaDisk file \'%s\' copied to \'%s\'\n",
    "(%s) %s: Unable to open file \'%s\'\n",                       /* Msg 15 */
    "(%s) %s: Unable to assign buffer to file \'%s\'\n",
    "(%s) %s: Unknown error writing %s to file \'%s\'\n",          /* Msg 17 */
    "(%s) %s: %u bytes from track %u (offset %04Xh) written to \'%s\'\n",
    "(%s) %s: \'%s\' (%u bytes) contains %s array %c (%u elem. in %u dims.)\n",
    "(%s) %s: %s: file \'%s\' written as CODE\n",                  /* Msg 20 */
    "(%s) %s: %s access failed on track %u of file \'%s\'\n",
    "(%s) %s: Wrong track read: expected track %u, got track %u\n",
    "(%s) %s: Interleave adjusted; now set to %u:1\n",             /* Msg 23 */
    "(%s) %s: Unable to determine autoRUN linenumber of program \'%s\'\n",
    "(%s) %s: Program \'%s\' runs from line %u\n",                 /* Msg 25 */
    "(%s) %s: Rename file \'%s\' to \'%s\'\n",
    "(%s) %s: BetaDisk file \'%s\' may be an unconvertible snapshot\n",
    "(%s) %s: Checksum for the %s block of file \'%s\' is %02Xh\n",
    "(%s) %s: Definition of \'%s\' too long; truncated\n",
    "(%s) %s: $HOME not defined; searching \'.bdderc\' in current directory\n",
    "(%s) %s: Memory allocated on heap at 0x%p to hold %s\n",
    "(%s) %s: Memory on heap at 0x%p holding %s freed\n",
    SettingsFormat,
    "(%s) %s: Arguments; ",
    "(%s) %s: Error %sing %s-file \'%s\'\n",
    "(%s) %s: %s-file \'%s\' not found\n",
    "(%s) %s: File \'%s\' probably not a BetaDisk; media descriptor: %02Xh\n",
    "(%s) %s: Target directory \'%s\' does not exist\n",
    "(%s) %s: No memory on heap left to hold %s\n",
    "(%s) %s: Illegal command \'%s\' ignored\n",
    "(%s) %s: Exiting shell; %d (fatal) error(s) encountered\n"
  };

  va_list ErrArgs;

  fflush (stdout);

  va_start (ErrArgs, MsgNo);
  vfprintf (stderr, EMsg [MsgNo], ErrArgs);
  va_end (ErrArgs);

  fflush (stderr);

  if ((ErrLvl == FATAL) || ((O_DbgLvl == ERROR) && (ErrLvl >= ERROR)))
     if (_CAL_) exit (ErrLvl);
     else
       {
         CleanUp ();
         longjmp (ShellErr, ++Fatals);
       }
}


/*
This routine shows all settings in DEBUG-setting or according option.
*/

#ifndef ARCHAIC
  void ShowSettings (char *funct, char *setting, char *moment)
#else
  void ShowSettings (funct, setting, moment) char *funct; char *setting;
       char moment;
#endif

{
  ErrMsg (MCURSETS, ERRSTAT, funct, setting, moment,
          (unsigned) O_odTrk,      (unsigned) O_DbgLvl,
          (unsigned) O_DataType,   (unsigned) O_ConverType,
          (unsigned) O_MediaType,  (unsigned) O_InterLeave,
          O_DataChar, O_BetaDump,
#ifdef DRDOS
          O_Spectrum,
#endif
          O_Prompt,
          TOBOOL (_LNG_), TOBOOL (_FSL_), TOBOOL (_SEF_), TOBOOL (_FDC_),
          TOBOOL (_SMS_), TOBOOL (_ASC_));

#ifdef DRDOS
  fprintf (stderr, "Available memory on heap     = %u bytes\n", coreleft ());
#endif
}


/*
This routine prints all arguments of type **char. Is used when O_DbgLvl has
been set to FLOW.
*/

#ifndef ARCHAIC
  void PrintArgs (char **Pargs, char *VarName)
#else
  void PrintArgs (Pargs, VarName) char **Pargs; char *VarName;
#endif

{
  unsigned x;

  for (x = 0; Pargs [x]; x++)
      fprintf (stderr, "(char*)%s[%u]=%s ", VarName, x, Pargs [x]);

  fputs ("\n", stderr);
}


/*
A disk has to be unmounted, hasn't it? Called before the program exists.
*/

#ifndef ARCHAIC
  void UnMountDisk (void)
#else
  void UnMountDisk ()
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "UnMountDisk");
        fputs ("NONE\n", stderr);
     }

  if (_BFO_)
     {
       if ((fclose (BetaDumpFp)) && (CHECK (ERROR)))
          ErrMsg (MERRFILE, ERRSTAT, "UnMountDisk", "unmount", BetaDump);
       _BFO_ = FALSE;
     }

  if (_FFL_)
     {
       if (CHECK (DEBUG))
          ErrMsg (MHPFREED, ERRSTAT, "UnMountDisk", FileList, "listfile");
       free_va (FileList); _FFL_ = FALSE;
     }
}


/*
This routine resets most variables and cleans up the mess after an
unscheduled break while executing the shell.
*/

#ifndef ARCHAIC
  void CleanUp (void)
#else
  void CleanUp ()
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "CleanUp");
        fputs ("NONE\n", stderr);
     }

  _LNG_ = _FDC_ = _SEF_ = _ASC_ = _FSL_ = _TF2_ = FALSE;
  O_DataType = UNKNOWN;                /* Resets defaults */

  if (_FPC_)
     {
       free (PendCall);
       _FPC_ = FALSE;
       if (CHECK (DEBUG))
          ErrMsg (MHPFREED, ERRSTAT, "CleanUp", PendCall, "internal call");
     }

  if (_FFL_ || _BFO_) UnMountDisk ();

  FileList = NULL;
}


/*
This routine simply converts a logical tracknumber and logical sectornumber to
an absolute sector.
*/

#ifndef ARCHAIC
  unsigned LogTS_to_AbsSc (unsigned char LogTk, unsigned char LogSc)
#else
  unsigned LogTS_to_AbsSc (LogTk, LogSc) unsigned char LogTk;
           unsigned char LogSc;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "LogTS_to_AbsSc");
        fprintf (stderr, "(unsigned char)LogTk=%u (unsigned char)LogSc=%u\n",
                 (unsigned) LogTk, (unsigned) LogSc);
     }

  return (((unsigned) LogTk << 4) + LogSc);
}


/*
This routine does something similar. It converts a logical track number to a
fysical tracknumber.
*/

#ifndef ARCHAIC
  unsigned char LogTk_to_FysTk (unsigned char LogTk)
#else
  unsigned char LogTk_to_FysTk (LogTk) unsigned char LogTk;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "LogTk_to_FysTk");
        fprintf (stderr, "(unsigned char)LogTk=%u\n", (unsigned) LogTk);
     }

  if (DSd) return (LogTk >> 1);
  else return (LogTk);
}


/*
Another conversion routine. It finds out on which side a logical track is
located.
*/

#ifndef ARCHAIC
  unsigned char LogTk_to_FysSd (unsigned char LogTk)
#else
  unsigned char LogTk_to_FysSd (LogTk) unsigned char LogTk;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "LogTk_to_FysSd");
        fprintf (stderr, "(unsigned char)LogTk=%u\n", (unsigned) LogTk);
     }

  if (DSd) return (LogTk & 1);
  else return (0);
}


/*
This routine is the only one that actually read from the BetaDisk dump. It
reads No. bytes into an array of unsigned char. It is a rather numb routine.
Where the bytes have to be put is controlled by GetTrk(). The checking is
rather stiff.
*/

#ifndef ARCHAIC
  void FillBuf (unsigned char *buf, int No)
#else
  void FillBuf (buf, No) unsigned char *buf; int No;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "FillBuf");
        fprintf (stderr, "(unsigned char*)buf=0x%p (int)No=%d\n",
                 buf, No);
     }

  if (fread (buf, sizeof (char), No, BetaDumpFp) != No)
     {
       if (feof (BetaDumpFp))
         {
           if (CHECK (FATAL))
              ErrMsg (MEOFDMP, ERRSTAT, "FillBuf", BetaDump);
         }

       else
         {
           if (CHECK (FATAL))
              ErrMsg (MNODREAD, ERRSTAT, "FillBuf", BetaDump);
         }
     }
}


/*
If GetTrk() fails to read in the first track correctly, GetILeave() will try to
find out the interleave of that sector. If it fails, it will return the
original pointer. If it succeeds O_InterLeave will be set accordingly. It return
the correct position of the entry in *Table[]. It may be called several times.
However, only the last call is significant. All interleaves from 1:1 up to
8:1 are supported.
*/

#ifndef ARCHAIC
  char *GetILeave (char *Table [], unsigned char SecHd, char *OrgP, char Seq)
#else
  char *GetILeave (Table, SecHd, OrgP, Seq) char *Table []; unsigned char SecHd;
        char *OrgP; char Seq;
#endif

{
  char x = 0;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "GetILeave");
        fprintf (stderr, "(char**)Table=0x%p (unsigned char)SecHd=%u \
(char*)OrgP=0x%p (char)Seq=%d\n", Table, (unsigned) SecHd, OrgP, (int) Seq);
     }

#ifndef DEMO
  if (!_FIL_)
     for (;x < 8; x++)
         if (SecHd == Table [x][Seq])
            {
              if (CHECK (DEBUG))
                 ErrMsg (MINTADJ, ERRSTAT, "GetILeave", x + 1);
              return (&(Table [(O_InterLeave = x)] [Seq]));
            }
#endif

  if (CHECK (ERROR))
     ErrMsg (MINVHEAD, ERRSTAT, "GetILeave", "Fys. sector", SecHd,
            "Calc. sector", *OrgP);

  return (OrgP);
}


/*
This routine reads and checks an Anadisk header for consistancy. If an error
is detected on the first track, GetILeave() is called to clean op the mess.
*/

#ifndef ARCHAIC
  char *CheckHeader (char *SecTable [], char *BufP, char BufN,
                     unsigned char LogTk)
#else
  char *CheckHeader (SecTable, BufP, BufN, LogTk) char *SecTable []; char *BufP;
       char BufN; unsigned char LogTk;
#endif

{
  unsigned char HdrBuf [8];

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "CheckHeader");
        fprintf (stderr,"(char**)SecTable=0x%p (char*)BufP=0x%p (char) BufN=%u \
(unsigned char)LogTk=%u\n", SecTable, BufP, (unsigned) BufN, (unsigned) LogTk);
     }

  FillBuf (HdrBuf, 8);

  if ((HdrBuf [0] != HdrBuf [2]) && (CHECK (ERROR)))
     ErrMsg (MINVHEAD, ERRSTAT, "CheckHeader", "Fys. track", HdrBuf [0],
                                      "Log. track", HdrBuf [2]);

  if ((HdrBuf [0] != Ftk) && (CHECK (ERROR)))
     ErrMsg (MINVHEAD, ERRSTAT, "CheckHeader", "Fys. track", HdrBuf [0],
                                      "Calc. track", Ftk);

  if ((HdrBuf [1] != Fsd) && (CHECK (ERROR)))
     ErrMsg (MINVHEAD, ERRSTAT, "CheckHeader", "Fys. side", HdrBuf [1],
                                      "Calc. side", Fsd);

  if (HdrBuf [4] != *BufP)
     {
       if ((LogTk > 0) && (CHECK (ERROR)))
          ErrMsg (MINVHEAD, ERRSTAT, "CheckHeader", "Fys. sector", HdrBuf [4],
                  "Calc. sector", *BufP);
       else BufP = (GetILeave (SecTable, HdrBuf [4], BufP, BufN));
     }

  if (CHECK (DEBUG))
     ErrMsg (MEXPTSS, ERRSTAT, "CheckHeader", Ftk, Fsd, *BufP, HdrBuf [0],
             HdrBuf [1], HdrBuf [4], ((unsigned) (*BufP - 1) << 8));

  return (BufP);
}


/*
This routine alternately calls FillBuf() to read in a sector header or a
sector. First the header is checked for consistancy by CheckHeader() when
mediatype AnaDisk is selected. Then the sector is read. It has a table to
control the sector interleave. If a sector on the first track on an Anadisk
fails, GetILeave() is called. It does not sort the sectors, it just reads them
in at the right place in the buffer. It reads a complete track (i.e. 16
sectors). The positioning to the right track is done by another routine
SeekTrk(). It also sets the Absolute Sector-, Fysical Track- and Fysical Side
variables.
*/

#ifndef ARCHAIC
  void GetTrk (unsigned char LogTk)
#else
  void GetTrk (LogTk) unsigned char LogTk;
#endif

{
  static char *FscSeq [] =
  {
    "\x1\x2\x3\x4\x5\x6\x7\x8\x9\xA\xB\xC\xD\xE\xF\x10",   /* 1:1 */
    "\x1\x9\x2\xA\x3\xB\x4\xC\x5\xD\x6\xE\x7\xF\x8\x10",   /* 2:1 */
    "\x1\xC\x7\x2\xD\x8\x3\xE\x9\x4\xF\xA\x5\x10\xB\x6",   /* 3:1 */
    "\x1\x5\x9\xD\x2\x6\xA\xE\x3\x7\xB\xF\x4\x8\xC\x10",   /* 4:1 */
    "\x1\xE\xB\x8\x5\x2\xF\xC\x9\x6\x3\x10\xD\xA\x7\x4",   /* 5:1 */
    "\x1\x9\x4\xC\x7\xF\x2\xA\x5\xD\x8\x10\x3\xB\x6\xE",   /* 6:1 */
    "\x1\x8\xF\x6\xD\x4\xB\x2\x9\x10\x7\xE\x5\xC\x3\xA",   /* 7:1 */
    "\x1\x3\x5\x7\x9\xB\xD\xF\x2\x4\x6\x8\xA\xC\xE\x10"    /* 8:1 */
  };

  char *p;
  char  n;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "GetTrk");
        fprintf (stderr, "(unsigned char)LogTk=%u\n", (unsigned) LogTk);
     }

  if ((LogTk != Ltk) && (CHECK (ERROR)))
      ErrMsg (MINVTRK, ERRSTAT, "GetTrk", Ltk, LogTk);

  Asc = LogTS_to_AbsSc (LogTk, 0);
  Ftk = LogTk_to_FysTk (LogTk);
  Fsd = LogTk_to_FysSd (LogTk);

  for (p = FscSeq [O_InterLeave], n = 0; *p; p++, n++)
      {
        if (O_MediaType == ANADUMP) p = CheckHeader (FscSeq, p, n, LogTk);
        FillBuf (TrkBuf + ((unsigned) (*p - 1) << 8), BYTE_SEC);
      }
}


/*
This routine positions the virtual 'head' to the requested track, then calls
GetTrk() to read the track into the buffer. It is apart from MountDisk() the
only routine that can call GetTrk(). It is however the only one that updates
Ltk.

It has two methods to get where it wants to go, provided one has the registered
version. The first is sequential. In most cases it is the fastest, since it
does not require a call to fseek() and all files on the BetaDisk are
contigious. However, when using `od` on a far away track this can get tiresome.
Then fseek() can provide much faster access.

It can also be useful when the disk contains a lot of deleted files which do
not have to be salvaged, since sequential access also reads in all unnecessary
tracks in between. In theory, it can also be useful then an entry points to a
track which lies before the current track. However, this is very unlikely.

When a track is required that is already in the buffer is returns. In the
unregistered version SeekTrk() repositions the track and reads it in again. In
sequential mode it doesn't differ very much from the registered version.
*/

#ifndef ARCHAIC
  int SeekTrk (unsigned char ReqLtk)
#else
  int SeekTrk (ReqLtk) unsigned char ReqLtk;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "SeekTrk");
        fprintf (stderr, "(unsigned char)ReqLtk=%u\n", (unsigned) ReqLtk);
     }

  if (Ltk == ReqLtk) return (0);

  if (_SMS_)
     {
#ifndef DEMO
       if (fseek (BetaDumpFp, (long) ReqLtk * TrackSize, SEEK_SET) != 0)
          {
            if (CHECK (ERROR))
               ErrMsg (MNOACCES, ERRSTAT, "SeekTrk", "Random", ReqLtk, BetaDump);
            return (-1);
          }

       else GetTrk ((Ltk = ReqLtk));
#endif
     }
  else
     {
       if (Ltk > ReqLtk)
          {
            if (CHECK (ERROR))
               ErrMsg (MNOACCES, ERRSTAT, "SeekTrk", "Sequential", ReqLtk,
                       BetaDump);
            return (-1);
          }
       else for (;Ltk < ReqLtk; GetTrk (++Ltk));
     }

  return (0);
}


/*
*Boots points to the nineth sector (08h) of track 0 which provides some
technical information. All disk administration is done on track 0 of the
BetaDisk. It seems strange that only 9 of the 16 sectors are actually used.
Using the other 7 sectors could have provided 112 file entries more.

Some of the entries of this report are hardcoded, since they are the same for
all disks. It is the only command that does not exist in Unix. In fact, it is
from Norton Utilities V4.5. Why did they got rid of these nice, short filenames
in V5 I never understood.
*/

#ifndef ARCHAIC
  void DiskInfo (unsigned char *Boots)
#else
  void DiskInfo (Boots) unsigned char *Boots;
#endif

{
  static char *Format [] =             /* Naar DiskInfo */
  {
    "80 tracks, double sided",
    "40 tracks, double sided",
    "80 tracks, single sided",
    "40 tracks, single sided",
    "Unknown"
  };
  unsigned char DiskType = Boots [BDISKTYP] - 22;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "DiskInfo");
        fprintf (stderr, "(unsigned char*)Boots=0x%p\n", Boots);
     }

  puts   (dfHdr);
  printf ("%s%25s       %s%4Xh\n",
          "Format....", Format [DiskType < 4 ? DiskType : 4],
          "Media descriptor................", (unsigned) Boots [BDISKTYP]);
  printf ("%s%4u       %s%5u\n",
          "Heads..........................", (unsigned) DSd + 1,
          "Total sectors...................", (unsigned) Tracks * (DSd+1) * 16);
  printf ("%s%4u       %s%5u\n",
          "Cylinders......................", (unsigned) Tracks,
          "Bytes per sector................", BYTE_SEC);
  puts   (dfBdy);
  printf ("%s%4u       %s%5u\n",
          "Ending head....................", (unsigned) DSd,
          "First sector of data area.......", SECT_DIR);
  printf ("%s%4u\n",
          "Ending cylinder................", (unsigned) Tracks - 1);
  puts   ("Ending sector..................  16");
}


/*
This routine is called from VolInfo() and only does some nicely formatted
printing of a line with diskspace information.
*/

#ifndef ARCHAIC
  void ShoSpace (unsigned int Space, char *Label)
#else
  void ShoSpace (Space, Label) unsigned int Space; char *Label;
#endif

{
  char NoSectors [15]; NoSectors [14] = '\0';

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "ShoSpace");
        fprintf (stderr, "(unsigned)Space=%u (char*)Label=%s\n",
                 Space, Label);
     }

  if (Space > 9999) Space = 9999;
  memset (NoSectors, ' ', 14);
  sprintf (NoSectors, "(%u sectors)", Space);
  printf  ("%3u kb, %14s %s\n", Space / 4, NoSectors, Label);
}


/*
This routine also prints some information from the nineth sector, how many
files are on disk, how many space they occupy, etc. Even the password. Luckily,
some third-party software developers provided BetaDisk users with tools to read
this password. I believe they got rid of the whole thing in the BetaDisk plus
version. It calls ShoSpace() to do some formatting.
*/

#ifndef ARCHAIC
  void VolInfo (unsigned char *BootSector)
#else
  void VolInfo (BootSector) unsigned char *BootSector;
#endif

{
  unsigned int  TotSect  = Tracks * (DSd + 1) * SECT_TRK;
  unsigned int  FreeSect = ((unsigned) BootSector [BMSBFREE] << 8)
                           + BootSector [BLSBFREE];

  char Labels   [10];
  char FileStat [26];

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "VolInfo");
        fprintf (stderr, "(unsigned char*)BootSector=0x%p\n", BootSector);
     }

  Labels [9] = '\0'; FileStat [25] = 0;

  sprintf (FileStat, "in %u files, %u deleted", (unsigned)BootSector [BNOFILES],
          (unsigned) BootSector [BDELFILE]);

  memcpy (Labels, &BootSector [BDISKNAM], 9);
  printf ("\n%16s %s\n", "Volume label is:", Labels),

  memcpy (Labels, &BootSector [BPASSWRD], 9);
  printf ("%16s %s\n\n", "Password is:", Labels);

  ShoSpace (TotSect, "total");
  ShoSpace (TotSect - FreeSect - SECT_DIR, FileStat);
  ShoSpace (SECT_DIR, "in directory");
  ShoSpace (FreeSect, "free");
}


/*
This routine opens the dumpfile and reads the first track (0h). It also sets up
the buffer for registered users. The buffer is exactly the size of one track.
It is the only routine that can call GetTrk() directly apart from SeekTrk(). It
also sets some important variables like how many sides the disk has and how
many files to expect. However, BDp is only used for checking, not for setting
up the number of entries. Unregistered users only have standard buffering.
*/

#ifndef ARCHAIC
  void MountDisk (void)
#else
  void MountDisk ()
#endif

{
  unsigned char *Bootp = TrkBuf + BOOTOFFS;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "MountDisk");
        fputs ("NONE\n", stderr);
     }

  Ltk = 0;

  TrackSize = (O_MediaType == ANADUMP ? BYTE_ANA : BYTE_TRK);

  if ((BetaDumpFp = fopen (O_BetaDump, "rb")) == NULL)
     {
       if (CHECK (FATAL))
            ErrMsg (MNOMOUNT, ERRSTAT, "MountDisk", O_BetaDump);
     }
#ifndef DEMO
  else
    {
      if (setvbuf (BetaDumpFp, InpBuf, _IOFBF, TrackSize) != 0)
         if (CHECK (ERROR))
            ErrMsg (MNOBUFF, ERRSTAT, "MountDisk", O_BetaDump);
      _BFO_ = TRUE;
    }
#else
  else _BFO_ = TRUE;
#endif

  BetaDump = basename (O_BetaDump);
  GetTrk (0);

  if ((Bootp [BDISKTYP] < 22) || (Bootp [BDISKTYP] > 25))
     if (CHECK (ERROR))
        ErrMsg (MNOBDISK, ERRSTAT, "MountDisk", BetaDump,
               (unsigned) Bootp [BDISKTYP]);

  Tracks = ((Bootp [BDISKTYP] % 2) == 1 ? 40 : 80);
  DSd = (Bootp [BDISKTYP] > 23 ? 0 : 1);
  BDp = (_SEF_ ? Bootp [BNOFILES] : Bootp [BNOFILES] - Bootp [BDELFILE]);
  Dp  = 0;
}


/*
Like Unix, BetaDisk filenames are case sensitive. Unlike anything, they could
also include things like spaces. If the conversion to DOS or Unix filenames
fails because that name has already been used to write a file to disk, this
routine is called. First it tries to write a file to disk, changing the last
character of the name to '0' up to '9'.

If somebody tries to bug this program by using more than eleven combinations of
the same upper and lower case filenames of the same type, another strategy is
used. This one can write up to 26^5 different filenames. That should be
adequate. Note that the Unix-version writes lower case filenames.
*/

#ifndef ARCHAIC
  void PatchName (unsigned int DirLen, unsigned int PatchPos, char Warning)
#else
  void PatchName (DirLen, PatchPos, Warning) unsigned int DirLen;
       unsigned int PatchPos; char Warning;
#endif

{
  unsigned int len = DirLen + PatchPos;
  unsigned char PatchChar;
  unsigned char PatchHead = (PatchPos < strlen (Headname)) ? TRUE : FALSE;
  char OldName [13];

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "PatchName");
        fprintf (stderr, "(unsigned)DirLen=%u (unsigned)PatchPos=%u \
(char)Warning=%s\n", DirLen, PatchPos, TOBOOL (Warning));
     }

  strcpy (OldName, basename (DOSFname));
  DOSFname [len] = '0';

  if (PatchHead)
     {
       PatchChar = Headname [PatchPos];
       Headname [PatchPos] = '0';
     }

  for (;
        (!access (DOSFname, 0)) && (DOSFname [len] <= '9');
        (DOSFname [len])++
      ) if (PatchHead) (Headname [PatchPos])++;

  if (DOSFname [len] <= '9') return;

  if (DirLen == 0) strcpy (DOSFname, "bddeXXXXXX");
  else
    {
      DOSFname [DirLen] = '\0';
      strcat (DOSFname, "bddeXXXXXX");
    }

  mktemp (DOSFname);

  if (PatchHead) Headname [PatchPos] = PatchChar;

  if ((CHECK (WARN)) && (Warning))
     ErrMsg (MRENAMEF, ERRSTAT, "PatchName", basename (DOSFname), OldName);
}


/*
This routine filters out all characters not allowed in Unix or DOS filenames,
thus making an acceptable filename. It also includes the optional target-
directory name. Then it appends an extension. BASIC files get .BAS, CODE files
.COD and DATA files either .NMB or .CHR with a Lunter-type conversion. Gandler-
type converted files do *not* get an extension, in accordance to the way the
Atari processes file/header names. Fhair files get a .__B, .__C, .__N or .__R
extension. Spectrum V2 emulator files end with .TAP, whatever type they are.
Finally it checks if there is already a file by that name on disk. If it is,
PatchName() is called.
*/

#ifndef ARCHAIC
  char *GetName (char *BDiskname, unsigned char Type)
#else
  char *GetName (BDiskname, Type) char *BDiskname; unsigned char Type;
#endif

{
  static char *NotOK = "|?`\'\"/\\<>,.:;+=%*";
  char *p;
  unsigned int Next = 0;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "GetName");
        fprintf (stderr, "(char*)BDiskname=%s (unsigned char)Type=%u\n",
                 BDiskname, (unsigned) Type);
     }

  strcpy (DOSFname, TgtDir);
  Next = strlen (DOSFname);

  for (p = BDiskname; *p; p++)
      if ((isgraph ((int) *p)) && (strchr (NotOK, *p) == NULL))
         DOSFname [Next++] = (char) tolower ((int) *p);

  DOSFname [Next] = '\0';

  if ((DOSFname [Next - 1] == _DS_) || (Next == 0))
     strcat (DOSFname, "noname");

  strcpy (Headname, basename (DOSFname));

  switch (O_ConverType)
  {
    case (NONE):
    case (LUNTER):

      switch (Type)
      {
        case (BASIC) : strcat (DOSFname, ".bas"); break;
        case (CODE)  : strcat (DOSFname, ".cod"); break;
        case (NUMBER): strcat (DOSFname, ".nmb"); break;
        case (STRING): strcat (DOSFname, ".chr"); break;
      }

      break;

    case (GANDLER):
      break;

    case (PHAIR):

      for (Next = 0, p = basename (DOSFname); Headname [Next]; Next++)
          if (!(isalnum ((int) Headname [Next])))
             {
               Headname [Next] = '_';
               p [Next] = '_';
             }

      if ((Next = strlen (basename (DOSFname))) < 8)
         {
           for (p = &(DOSFname [strlen (DOSFname)]); Next < 8; p++, Next++)
               *p = '_';
           *p = '\0';
         }

      switch (Type)
      {
        case (BASIC) : strcat (DOSFname, ".__b"); break;
        case (CODE)  : strcat (DOSFname, ".__c"); break;
        case (NUMBER): strcat (DOSFname, ".__n"); break;
        case (STRING): strcat (DOSFname, ".__r"); break;
      }

      break;

    case (Z80V2):
      strcat (DOSFname, ".tap"); break;
  }

  if (!access (DOSFname, 0))
     {
       switch (O_ConverType)
       {
         case (NONE):
         case (LUNTER):
           PatchName (strlen (DOSFname) - strlen (basename (DOSFname)),
                      strlen (basename (DOSFname)) - 1, FALSE);
           break;
         case (GANDLER):
           PatchName (strlen (DOSFname) - strlen (basename (DOSFname)),
                      strlen (basename (DOSFname)) - 1, TRUE);
           break;
         case (PHAIR):
           PatchName (strlen (DOSFname) - strlen (basename(DOSFname)), 0, TRUE);
           break;
         case (Z80V2):
           PatchName (strlen (DOSFname) - strlen (basename(DOSFname)), 0,TRUE);
           break;
       }
     }

  return (DOSFname);
}


/*
This is the only routine that actually writes to the MS-DOS file. It
writes NoBytes from BlockBuf and calculates the checksum for .TAP files.
When it succeeds it returns 1 else 0. If both CalcSum and V2TapeFormat are
TRUE a checksum is calculated. This only happens when writing a header or
a datablock. Not when a flagblock or the checksum itself are written!
*/

#ifndef ARCHAIC
  char WriteBlock (unsigned char *BlockBuf, size_t NoBytes, char *Action,
                   char CalcSum)
#else
  char WriteBlock (BlockBuf, NoBytes, Action, CalcSum) unsigned char *BlockBuf;
       size_t NoBytes; char *Action; char CalcSum;
#endif

{
#ifndef DEMO
  unsigned x;
#endif

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "WriteBlock");
        fprintf (stderr, "(unsigned char*)BlockBuf=0x%p (size_t)NoBytes=%u \
(char*)Action=%s (char)CalcSum=%s\n", BlockBuf, (unsigned) NoBytes, Action,
               TOBOOL (CalcSum));
     }

  if ((fwrite (BlockBuf, sizeof (unsigned char), NoBytes, DOSFp)) != NoBytes)
     {
       if (CHECK (ERROR))
          ErrMsg (MNOFWRIT, ERRSTAT, "WriteBlock", Action, DOSFname);
       return (0);
     }

  else
    {
#ifndef DEMO
      if (_TF2_ && CalcSum)
         for (x = 0; x < NoBytes; x++) ChkSum ^= BlockBuf [x];
#endif
      return (1);
    }
}


/*
This routine is only used when writing a .TAP file of an Z80 V2 emulator. It
writes the flagblock and initializes the checksum.
*/

#ifndef ARCHAIC
  void MakeFlag (size_t BlkLen, unsigned char FlagByte)
#else
  void MakeFlag (BlkLen, FlagByte) size_t BlkLen; unsigned char FlagByte;
#endif

{
  unsigned char FlagBlk [3];

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "MakeFlag");
        fprintf (stderr, "(size_t)BlkLen=%u (unsigned char)FlagByte=%u\n",
                 (unsigned) BlkLen, (unsigned) FlagByte);
     }

  BlkLen += 2;

  FlagBlk [HLEN_LSB] = LSB (BlkLen);
  FlagBlk [HLEN_MSB] = MSB (BlkLen);
  FlagBlk [HBLK_TYP] = ChkSum = FlagByte;

#ifndef DEMO
  WriteBlock (FlagBlk, 3, "flag", FALSE);
#endif
}


/*
This routine writes the Spectrum RS232 header. The header consists of nine
bytes. Unused bytes contain 255 (FFh). The first byte holds the filetype, the
next two the total length and the last two the address where the file has to be
loaded.

BASIC headers have an additional two bytes, which hold the programlength
(without data that is). DATA headers hold one additional byte containing the
upper case variable name with 64 (40h) for numbers or 128 (80h) for strings
added to it. Finally the header is written to disk.
*/

#ifndef ARCHAIC
  void MakeRS232Hd (unsigned char Entry, char SType)
#else
  void MakeRS232Hd (Entry, SType) unsigned char Entry; char SType;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "MakeRS232Hd");
        fprintf (stderr, "(unsigned char)Entry=%u (char)SType=%u\n",
                 (unsigned) Entry, (unsigned) SType);
     }

  memset (Header, '\xFF', 9);

  Header [SLSB_LEN] = LSB (Dirty [Entry].TotLen);
  Header [SMSB_LEN] = MSB (Dirty [Entry].TotLen);
  Header [SLSB_ADR] = LSB (Dirty [Entry].Address);
  Header [SMSB_ADR] = MSB (Dirty [Entry].Address);
  Header [SFILETYP] = SType;

  switch (Dirty [Entry].Type)
  {

    case 'B':
      Header [SLSB_BLN] = LSB (Dirty [Entry].Length);
      Header [SMSB_BLN] = MSB (Dirty [Entry].Length);
      break;

    case 'D':
      if (SType != UNKNOWN)
         Header [SARRAYCH] = O_DataChar + (SType << 6);
      if (!_FDC_) if (++O_DataChar > 'Z') O_DataChar = 'A';
      break;
  }

  WriteBlock (Header, 9, "RS232 header", FALSE);
}


/*
This routine writes the Spectrum tapeheader. The header consists of seventeen
bytes. The first byte holds the filetype, the next ten the filename, the
next two the total length and next four type-specific information. Note that
in order to provide Atari, Spectrum V2 and SpecEm-compatibility the headername
and the filename need to be synchronized.

BASIC headers use all four bytes, which hold the programlength (without data
that is) and autostart linenumber. DATA headers hold one additional byte
containing the upper case variable name with 64 (40h) for numbers or 128 (80h)
for strings added to it. CODE headers use only two bytes for their
startaddress. Finally the header is written to disk.
*/

#ifndef ARCHAIC
  void MakeTapeHd (unsigned char Ntry, char TType)
#else
  void MakeTapeHd (Ntry, TType) unsigned char Ntry; char TType;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "MakeTapeHd");
        fprintf (stderr, "(unsigned char)Ntry=%u (char)TType=%u\n",
                 (unsigned) Ntry, (unsigned) TType);
     }

  if (_TF2_) MakeFlag (17, HEAD_BLK);

  memset (Header, '\0', 17);

  sprintf ((char *) Header + 1, "%-10s", Headname);
  Header [TLSB_LEN] = LSB (Dirty [Ntry].TotLen);
  Header [TMSB_LEN] = MSB (Dirty [Ntry].TotLen);
  Header [TFILETYP] = TType;

  switch (Dirty [Ntry].Type)
  {
    case 'B':
      Header [TMSB_RUN] = '\x80';
      Header [TLSB_BLN] = LSB (Dirty [Ntry].Length);
      Header [TMSB_BLN] = MSB (Dirty [Ntry].Length);
      break;

    case 'C':
      Header [TLSB_ADR] = LSB (Dirty [Ntry].Address);
      Header [TMSB_ADR] = MSB (Dirty [Ntry].Address);
      break;

    case 'D':
      if (TType != UNKNOWN) Header [TARRAYCH] = O_DataChar + (TType << 6);
      else
        {
          Header [TLSB_ADR] = LSB (Dirty [Ntry].Address);
          Header [TMSB_ADR] = MSB (Dirty [Ntry].Address);
        }

      if (!_FDC_) if (++O_DataChar > 'Z') O_DataChar = 'A';
      break;
  }

  WriteBlock (Header, 17, "tape header", TRUE);

  if (_TF2_)
     if ((WriteBlock (&ChkSum, 1, "checksum", FALSE)) && (CHECK (DEBUG)))
        ErrMsg (MCHKSUM, ERRSTAT, "MakeTapeHd", "header", DOSFname, ChkSum);
}


/*
This routine is called from GetFType() when it encounters a DATA file and the
type has not been defined on the commandline. This information is NOT provided
on the BetaDisk and essential since character and number arrays have quite
different headers.

Basically, it tries to find out what the elementsize is. Numbers take up 5
bytes per element and characters one byte. The first byte on the first sector
of the DATA file provides the number of dimensions. Following that byte are the
sizes of these dimensions, each taking up two bytes in Zilog fashion (lsb
first). The first loop calculates the total number of elements. It should not
exceed 64 kb, although the Spectrum can not hold that amount of data anyway.

Following that are databytes. So the total data in that file is equal to the
the filesize minus the number of dimensions * 2 databytes + 1 databyte. If the
modulus of the number of databytes and the number of elements is not zero
something is wrong. Finally the element must be either 5 or 1 bytes long. If
not, either somebody messed around with his Spectrum ROM or we have some rare
data corruption. In that case the file will still be written, but have a CODE
type header.
*/

#ifndef ARCHAIC
  unsigned char GetAType (unsigned char lsp)
#else
  unsigned char GetAType (lsp) unsigned char lsp;
#endif

{
  unsigned char *Desc = TrkBuf + ((unsigned) Dirty [lsp].FLsc << 8);
  unsigned char NoDIM = Desc [0];
  unsigned char ArrayType = UNKNOWN;
  unsigned int  x = 1;
  unsigned int  DIM;
  unsigned int  ElemLen;
  unsigned long NoElem = 1;
  char TypeError = 0;
  static char *TypeName  [] = { "", "numeric", "character", "invalid" };
  static char *DataError [] =
  {
    "Too many dimensions",
    "Too many elements",
    "Corrupt data",
    "Unknown type"
  };

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "GetAType");
        fprintf (stderr, "(unsigned char)lsp=%u\n", (unsigned) lsp);
     }

  if (NoDIM < 128)
     {
       for (TypeError++; x <= NoDIM; x++)
           NoElem = NoElem * (unsigned long)
                    ((int) Desc [(x << 1) - 1] + ((int) Desc [x << 1] << 8));

       if (NoElem <= 65536L)
          {
             TypeError++;
             DIM = Dirty [lsp].TotLen - (1 + ((unsigned) NoDIM << 1));

            if ((ElemLen = DIM % (unsigned) NoElem) == 0)
               {
                 TypeError++;
                 ElemLen = DIM / (unsigned) NoElem;
                 if (ElemLen == 5) ArrayType = NUMBER;
                 if (ElemLen == 1) ArrayType = STRING;
               }
          }
     }

  if (CHECK (INFO))
     ErrMsg (MARRAYTP, ERRSTAT, "GetAType", Dirty [lsp].Filename,
             Dirty [lsp].TotLen, TypeName [ArrayType], O_DataChar,
             (unsigned) NoElem, (unsigned) NoDIM);

  if ((CHECK (ERROR)) && (ArrayType == UNKNOWN))
     ErrMsg (MWRITCOD, ERRSTAT, "GetAType", DataError [TypeError], DOSFname);

  return (ArrayType);
}


/*
This routine finds out exactly what kind of file is being processed. Basically
it distinguishes between numeric and character datatypes.
*/

#ifndef ARCHAIC
  char GetFType (unsigned char Didx)
#else
  char GetFType (Didx) unsigned char Didx;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "GetFType");
        fprintf (stderr, "(unsigned char)Didx=%u\n", (unsigned) Didx);
     }

  switch (Dirty [Didx].Type)
  {
    case ('B') : return (BASIC);
    case ('C') : return (CODE);
    case ('D') : if (O_DataType == UNKNOWN) return (GetAType (Didx));
                 else return (O_DataType);
    default    : return (CODE);
  }
}


/*
Strange, but the autoRUN linenumber is *not* saved in the BetaDisk directory
but right behind the BASIC-program itself. After the databytes itself #aa80
is saved in Zilog fashion, followed by the autoRUN linenumber. If the autoRUN
linenumber is still in the trackbuffer it can be listed. If only one byte is
left RunLine() fails. However, this only happens in one out of 4096 cases.
*/

#ifndef DEMO
#ifndef ARCHAIC
  void RunLine (unsigned char Ndx)
#else
  void RunLine (Ndx) unsigned char Ndx;
#endif

{
  unsigned Raddr;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "RunLine");
        fprintf (stderr, "(unsigned char)Ndx=%u\n", (unsigned) Ndx);
     }

  if ((Dirty [Ndx].NEG < RUNSLACK) && (Dirty [Ndx].LLsc == (SECT_TRK - 1)))
     {
       if (CHECK (WARN))
          ErrMsg (MNORUNLN, ERRSTAT, "RunLine", Dirty [Ndx].Filename);
     }

  else
    {
      Raddr = (((unsigned) (Dirty [Ndx].LLsc + (Dirty [Ndx].NEG < RUNSLACK ?
              1 : 0)) << 8) + ((Dirty [Ndx].TotLen + RUNSLACK) & 255)) - 2;

      if (CHECK (INFO))
          ErrMsg (MRUNLINE, ERRSTAT, "RunLine", Dirty [Ndx].Filename,
                  ((unsigned) TrkBuf [Raddr]) +
                  ((unsigned) TrkBuf [Raddr + 1] << 8));
    }
}
#endif


/*
This routine is a dumb, but very fast one. It is called from CopyFile() when a
file spans more than one fysical track. In the first run it only writes as many
sectors as there are left on the current track. Then it starts writing 4 kB
blocks (entire tracks) until it encounters the last track of the file, even if
that track completely belongs to the file currently written. As few as possible
checks are made. Written for speed. It returns the new sector (0).
*/

#ifndef ARCHAIC
  unsigned int FastTrk (unsigned char Lp, unsigned int Base)
#else
  unsigned int FastTrk (Lp, Base) unsigned char Lp; unsigned int Base;
#endif

{
  unsigned int Count = BYTE_TRK - Base;
  unsigned char FirstTrack = TRUE;
  unsigned char *Basep = TrkBuf + Base;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "FastTrk");
        fprintf (stderr, "(unsigned char)Lp=%u (unsigned)Base=%u\n",
                 (unsigned) Lp, Base);
     }

  for (;Ltk < Dirty [Lp].LLtk; SeekTrk (Ltk + 1))
  {
    if (WriteBlock (Basep, Count, "data", TRUE))
       if (CHECK (DEBUG))
          ErrMsg (MBYTWRIT, ERRSTAT, "FastTrk", Count, (unsigned) Ltk, Base,
                  DOSFname);

    if (FirstTrack)
       {
         Base = 0;
         Basep = TrkBuf;
         Count = BYTE_TRK;
         FirstTrack = FALSE;
       }
  }

  return (0);
}


/*
This routine controls the copying of a single file. First it calls SeekTrk() to
set the 'head' to the right track. Whether sequential or random is transparant.
When this fails, the file is NOT opened, but skipped. When opening of the file
fails the file is skipped too. For registered users a buffer is assigned, for
unregistered users there is only standard buffering.

Then a header is written, provided it is not disabled. Then the address in the
TrkBuf from which the transfer has to start is calculated. If the file does not
end on the same track FastTrk() is called. Whether a return from FastTrk() is
made or not, BaseAddr holds the correct value for writing the last few sectors.
The number of bytes which have to be written is calculated and a final write to
the file is made. Finally it closes the file and returns. When succesfull 0 is
returned, otherwise -1.
*/

#ifndef ARCHAIC
  int CopyFile (unsigned char Dirp)
#else
  int CopyFile (Dirp) unsigned char Dirp;
#endif

{
  unsigned char FType;
  unsigned int  Bytes, BaseAddr;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "CopyFile");
        fprintf (stderr, "(unsigned char)Dirp=%u\n", (unsigned) Dirp);
     }

  if (SeekTrk (Dirty [Dirp].FLtk)) return (-1);

  if ((DOSFp = fopen (GetName (Dirty [Dirp].Filename,
                     (FType = GetFType (Dirp))), "wb")) == NULL)
     {
       if (CHECK (ERROR)) ErrMsg (MNOFOPEN, ERRSTAT, "CopyFile", DOSFname);
       return (-1);
     }

#ifndef DEMO
  else
    if (setvbuf (DOSFp, OutBuf, _IOFBF, TGTBUF) != 0)
       if (CHECK (ERROR))
          ErrMsg (MNOBUFF, ERRSTAT, "CopyFile", DOSFname);
#endif

  switch (O_ConverType)
  {
    case (NONE)    : break;
    case (LUNTER)  : MakeRS232Hd (Dirp, FType); break;
    case (GANDLER) :
    case (PHAIR)   :
    case (Z80V2)   : MakeTapeHd  (Dirp, FType); break;
  }

  BaseAddr = (unsigned) Dirty [Dirp].FLsc << 8;

  if (_TF2_) MakeFlag (Dirty [Dirp].TotLen, DATA_BLK);

  if (Dirty [Dirp].LLtk != Ltk) BaseAddr = FastTrk (Dirp, BaseAddr);

  Bytes = ((((unsigned) Dirty [Dirp].LLsc + 1) << 8) - (BaseAddr +
          Dirty [Dirp].NEG));

  if (WriteBlock (TrkBuf + BaseAddr, Bytes, "data", TRUE))
     if (CHECK (DEBUG))
        ErrMsg (MBYTWRIT, ERRSTAT, "CopyFile", Bytes, (unsigned) Ltk, BaseAddr,
                DOSFname);

  if (_TF2_)
     if ((WriteBlock (&ChkSum, 1, "checksum", FALSE)) && (CHECK (DEBUG)))
        ErrMsg (MCHKSUM, ERRSTAT, "CopyFile", "data", DOSFname, ChkSum);

#ifndef DEMO
  if (Dirty [Dirp].Type == 'B') RunLine (Dirp);
#endif

  if ((fclose (DOSFp)) && (CHECK (ERROR)))
     ErrMsg (MERRFILE, ERRSTAT, "CopyFile", "clos", DOSFname);

  return (0);
}


/*
This routine is called from MakeEntry() when the `ls` command is invoked. It
writes a line of information about the currently processed entry.
*/

#ifndef ARCHAIC
  void DirInfo (unsigned char Entry, unsigned int Address,
                unsigned int Length, unsigned char NoSect)
#else
  void DirInfo (Entry, Address, Length, NoSect) unsigned char Entry;
       unsigned int Address; unsigned int Length; unsigned char NoSect;
#endif

{
  static char *Type [] = { "BASIC", "CODE", "DATA" };

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "DirInfo");
        fprintf (stderr, "(unsigned char)Entry=%u (unsigned)Address=%u \
(unsigned)Length=%u (unsigned char)NoSect=%u\n", (unsigned) Entry, Address,
                 Length, (unsigned) NoSect);
     }

  printf (lsFmt, Dirty [Entry].Filename,
                 Type [Dirty [Entry].Type -'B'],
                 Address, Length,
                 (unsigned) Dirty [Entry].NEG,
                 (unsigned) LogTk_to_FysTk (Dirty [Entry].FLtk),
                 (unsigned) LogTk_to_FysSd (Dirty [Entry].FLtk),
                 (unsigned) Dirty [Entry].FLsc + 1,
                 LogTS_to_AbsSc (Dirty [Entry].FLtk, Dirty [Entry].FLsc),
                 LogTS_to_AbsSc (Dirty [Entry].LLtk, Dirty [Entry].LLsc),
                 (unsigned) NoSect,
                 (unsigned) Dirty [Entry].FLtk,
                 (unsigned) Dirty [Entry].FLsc,
                 (unsigned) Dirty [Entry].LLtk,
                 (unsigned) Dirty [Entry].LLsc);
}


/*
This routine just checks whether the filename is in the filelist. If no
filelist is available it is always in the filelist ;-). Otherwise the
list is checked.
*/

#ifndef ARCHAIC
  char CheckList (char *BFname)
#else
  char CheckList (BFname) char *BFname;
#endif

{
  char **Listp;                        /* Temp. pointer to the filelist */
  char   WildCards;                    /* Indicator for wildcard status */
  char   ListID [9];                   /* Holds filename mask */
  char  *IDp;                          /* Temp. pointer to ListID */
  int    diff;                         /* To fix a bug in left */

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "CheckList");
        fprintf (stderr, "(char*)BFname=%s\n", BFname);
     }

  if (!FileList) return (TRUE);        /* No filelist? Always OK */
  else

    for (Listp = FileList; *Listp; Listp++)
        {                              /* Check against all entries */
          WildCards = NAME;            /* Setup indicator and filemask */
          Strncopy (ListID, *Listp, sizeof (ListID));
          IDp = ListID;

          if (IDp [0] == '*')          /* Left wildcard found? */
             {
               WildCards |= LEFT;
               IDp++;
             }                         /* Right wildcard found? */

          if (IDp [strlen (IDp) - 1] == '*')
             {
               WildCards |= RIGHT;
               IDp [strlen (IDp) - 1] = '\0';
             }
                                       /* Now compare filename and filemask */
          switch (WildCards)
          {
            case (NAME):  if (!strcmp (IDp, BFname)) return (TRUE);
                          break;
            case (LEFT):  diff = strlen (BFname) - strlen (IDp);
                          if ((diff >= 0) && (Strpos (IDp,BFname,0) == diff))
                             return (TRUE);
                          break;
            case (RIGHT): if (Strpos (IDp, BFname, 0) == 0) return (TRUE);
                          break;
            case (BOTH):  if (Strpos (IDp, BFname, 0) != -1) return (TRUE);
                          break;
          }
        }

        return (FALSE);                /* Nothing worked? Return not in list */
}


/*
This routine checks whether the number of sectors allocated equals the
filelength. This prevents that some random data in the directory section
of the BetaDisk confuses BDDE. When ForceSectorLen is disabled it will try to
make all information consistent again. If it isn't it just issues an error-
message.
*/

#ifndef ARCHAIC
  void CheckLength (unsigned char *BDndx, unsigned char DirEnt, unsigned AbSec)
#else
  void CheckLength (BDndx, DirEnt, AbSec) unsigned char *BDndx;
       unsigned char DirEnt; unsigned AbSec;
#endif

{
  unsigned CalcLen = Dirty [DirEnt].TotLen +
                     (Dirty [DirEnt].Type == 'B' ? RUNSLACK : 0);

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "CheckLength");
        fprintf (stderr, "(unsigned char*)BDndx=0x%p (unsigned char)DirEnt=%u \
(unsigned)AbSec=%u\n", BDndx, (unsigned) DirEnt, AbSec);
     }

  if ((CalcLen = ((CalcLen >> 8) + ((CalcLen & 255) > 0 ? 1 : 0))) !=
      BDndx [FNO_SECT])
     {
       if (CHECK (ERROR))
          ErrMsg (MFSDIFF, ERRSTAT, "CheckLength", Dirty [DirEnt].Filename,
                  CalcLen, BDndx [FNO_SECT]);

       if (_FSL_)
          {
            Dirty [DirEnt].Length = Dirty [DirEnt].TotLen =
                  ((unsigned) BDndx [FNO_SECT] << 8);

            if ((Dirty [DirEnt].Type == 'B') &&
                (Dirty [DirEnt].NEG < RUNSLACK))
               {
                 Dirty [DirEnt].LLtk = (++AbSec) >> 4;
                 Dirty [DirEnt].LLsc = AbSec & 15;
               }

            if (CHECK (WARN))
               ErrMsg (MFSADJ, ERRSTAT, "CheckLength", Dirty [DirEnt].Filename,
                       Dirty [DirEnt].Length);
          }
     }
}


/*
This routine is called from MakeDir() and fills the current free Dirty[] array
structure with all necessary information. When `ls` is invoked all other
information is transferred to DirInfo(), but not entered in Dirty[].

First, LAsc is assigned to the Last Absolute sector which still belongs to the
processed file-entry. Then the filename is copied to Dirty[], putting the null-
character after the last character of the filename. Secondly, the filetype, the
FLtk/FLsc, and LLtk/LLsc the file are set.

The next information is type dependent. It has little to do with the poor
Spectrum, but the BetaDisk uses these fields for different purposes to keep the
size of an entry down to 16 bytes. NEG contains the number of bytes on the last
sector that are not part of the file (slack). These are not written, but this
is not very important anyway since most emulators let the header decide how
many bytes are read into the Spectrum. The address where DATA or BASIC files
are written is ignored on the Spectrum.

On the BetaDisk V4, the CODE lengthfield held the runaddress, so the true
length has to be calculated by the number of sectors. The BASIC lengthfield
only holds the length of the program (without data that is). The real length is
held in the addressfield. The address that is assigned to a BASIC entry is the
value of the system variable PROG with Interface I installed. A check is made
to see if the autorun linenumber fits in the slack. If it doesn't more bytes
will be written than necessairy. This can corrupt a BASIC-file. However, it
isn't fatal, since the information from the header is used. It *will* show
if you start appending single .TAP files to a multiple .TAP file. It will
never get past the corrupted program! That's why it is checked from V1.4a on.

Then the routine checks whether the length according to BetaDisk matches the
number of sectors allocated. If not, a message is issued. When _FSL_ is
set the length in the header will be adjusted to match the number of sectors.
In most cases this is not necessary.

Finally, the first character of an erased file is set to '&' and the pointer
to the next directory entry (Dp) is incremented. When `ls` is invoked DirInfo()
is called.
*/

#ifndef ARCHAIC
  void MakeEntry (unsigned char *BDirp, char Command)
#else
  void MakeEntry (BDirp, Command) unsigned char *BDirp; char Command;
#endif

{
  unsigned int LAsc = ((BDirp [FFIRSTTK] << 4)
                      + BDirp [FFIRSTSC] + BDirp [FNO_SECT]) - 1;
  char *t;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "MakeEntry");
        fprintf (stderr, "(unsigned char*)BDirp=0x%p (char)Command=%u\n",
                 BDirp, (unsigned) Command);
     }

  memcpy (Dirty [Dp].Filename, BDirp, 8); /* Filename */
  for (t = &Dirty [Dp].Filename [7]; *t == ' '; t--); *(++t) = '\0';

  Dirty [Dp].Type = BDirp [FFILTYPE];  /* Filetype (B,C, or D) */
  Dirty [Dp].FLtk = BDirp [FFIRSTTK];  /* Logical Track  start file */
  Dirty [Dp].FLsc = BDirp [FFIRSTSC];  /* Logical Sector start file */
  Dirty [Dp].LLtk = LAsc >> 4;         /* Logical Track  end file */
  Dirty [Dp].LLsc = LAsc & 15;         /* Logical Sector end file */
  Dirty [Dp].Address = ((unsigned) BDirp [FMSBADDR] << 8) + BDirp [FLSBADDR];
  Dirty [Dp].Length  = ((unsigned) BDirp [FMSB_LEN] << 8) + BDirp [FLSB_LEN];

  switch (Dirty [Dp].Type)
  {
   case 'B':
     Dirty [Dp].NEG     = (unsigned char) BYTE_SEC - BDirp [FLSBADDR];
     Dirty [Dp].TotLen  = Dirty [Dp].Address;
     Dirty [Dp].Address = 23813;

     if (Dirty [Dp].NEG < RUNSLACK)
        {
          Dirty [Dp].LLtk = (--LAsc) >> 4;
          Dirty [Dp].LLsc = LAsc & 15;
        }

     break;

   case 'C':
     Dirty [Dp].NEG     = 0;
     Dirty [Dp].Length = Dirty [Dp].TotLen = ((unsigned)BDirp [FNO_SECT] << 8);

     if ((BDirp [FNO_SECT] == 192) && (CHECK (WARN)))
        ErrMsg (MSNAPSHT, ERRSTAT, "MakeEntry", Dirty [Dp].Filename);
     break;

   case 'D':
     Dirty [Dp].NEG     = (unsigned char) BYTE_SEC - BDirp [FLSB_LEN];
     Dirty [Dp].TotLen  = Dirty [Dp].Length;
     break;

   default:
     if  (CHECK (ERROR))
         ErrMsg (MNOTYPE, ERRSTAT, "MakeEntry", Dirty [Dp].Type,
                Dirty [Dp].Filename);

     Dirty [Dp].Type    = 'C';
     Dirty [Dp].NEG     = 0;
     Dirty [Dp].Length  = Dirty [Dp].TotLen = ((unsigned)BDirp [FNO_SECT] << 8);
     break;
  }

  CheckLength (BDirp, Dp, LAsc);

  if (Dirty [Dp].Filename [0] == '\1') Dirty [Dp].Filename [0] = '&';

  if (CheckList (Dirty [Dp].Filename))
     {
       if (Command == LS)
          {
            if (_LNG_) DirInfo (Dp, BDirp [FLSBADDR] +
                                ((unsigned) BDirp [FMSBADDR] << 8),
                                BDirp [FLSB_LEN] +
                                ((unsigned) BDirp [FMSB_LEN] << 8),
                                BDirp [FNO_SECT]);
            else puts (Dirty [Dp].Filename);
          }
       Dp++;
     }
  else BDp--;
}


/*
MakeDir() is called from both `ls` or `cp`. In both cases a directory needs to
be constructed. When called by `ls` a header is printed. The first free entry
on the BetaDisk directory contains 0. A BetaDisk cannot hold more than 128
entries. When _SEF_ is not set, erased files are skipped. Finally this
routine checks whether it has read as many files as BetaDisk reported.
*/

#ifndef ARCHAIC
  void MakeDir (char Cmd)
#else
  void MakeDir (Cmd) char Cmd;
#endif

{
  unsigned x;
  unsigned char *BetaDir, *f;
  unsigned char ErasedFn [8];

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "MakeDir");
        fprintf (stderr, "(char)Cmd=%u\n", (unsigned) Cmd);
     }

  if ((Cmd == LS) && (_LNG_)) puts (lsHdr);

  for (
       x = 0, BetaDir=TrkBuf;
       (BetaDir [FBETFNAM] != 0) && x < 128;
       BetaDir+=16, x++
      )
    {
      if ((BetaDir [FBETFNAM] > 1) || (_SEF_)) MakeEntry (BetaDir, Cmd);

      else if (CHECK (WARN))
        {
          memcpy (ErasedFn, BetaDir + 1, 7);
          for (f = ErasedFn + 6; *f == ' '; f--); *(++f) = '\0';
          ErrMsg (MERAFIND, ERRSTAT, "MakeDir", ErasedFn);
        }
    }

  if ((BDp != Dp) && (CHECK (ERROR)))
      ErrMsg (MBMOREF, ERRSTAT, "MakeDir", BDp > Dp ? "more" : "less", BDp, Dp);
}


/*
MakeCopy() seems a little less complicated than one would expect. However, it
calls CopyFile() and that one does all the hard work. When CopyFile() returns
-1 the file has been skipped.
*/

#ifndef ARCHAIC
  void MakeCopy (void)
#else
  void MakeCopy ()
#endif

{
  unsigned char x;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "MakeCopy");
        fputs ("NONE\n", stderr);
     }

  if (O_ConverType == Z80V2) _TF2_ = TRUE;

  MakeDir (CP);

  for (x = 0; x < Dp; x++)
      {
        if (CopyFile (x))
           {
             if (CHECK (WARN))
                ErrMsg (MBFSKIP, ERRSTAT, "MakeCopy", Dirty [x].Filename);
           }
        else
          if (CHECK (INFO))
             ErrMsg (MCPBFILE, ERRSTAT, "MakeCopy", Dirty [x].Filename,
                    DOSFname);
      }
}


/*
This routine just does what its name implies. It dumps a sector in hex. Each
row contains 16 bytes. Quick and dirty, but it works.
*/

#ifndef ARCHAIC
  void DumpHex (unsigned char Offset)
#else
  void DumpHex (Offset) unsigned char Offset;
#endif

{
  unsigned int Row;
  unsigned char *Index = TrkBuf + ((unsigned) Offset << 8);

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "DumpHex");
        fprintf (stderr, "(unsigned char)Offset=%u\n", (unsigned) Offset);
     }

  for (Row = 0; Row < BYTE_SEC; Row+=16)
      printf (odHex, Row, Row,
              (unsigned) Index [Row],      (unsigned) Index [Row + 1],
              (unsigned) Index [Row + 2],  (unsigned) Index [Row + 3],
              (unsigned) Index [Row + 4],  (unsigned) Index [Row + 5],
              (unsigned) Index [Row + 6],  (unsigned) Index [Row + 7],
              (unsigned) Index [Row + 8],  (unsigned) Index [Row + 9],
              (unsigned) Index [Row + 10], (unsigned) Index [Row + 11],
              (unsigned) Index [Row + 12], (unsigned) Index [Row + 13],
              (unsigned) Index [Row + 14], (unsigned) Index [Row + 15]);
}


/*
This is DumpHex()'s little sister. She dumps a sector in ascii. Each line is 64
characters long. Each non-printable character is replaced by a dot.
*/

#ifndef ARCHAIC
  void DumpAscii (unsigned char OffSet)
#else
  void DumpAscii (OffSet) unsigned char OffSet;
#endif

{
  unsigned int row;
  unsigned char x;
  unsigned char *index = TrkBuf + ((unsigned) OffSet << 8);
  unsigned char line [65]; line [64] = '\0';

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "DumpAscii");
        fprintf (stderr, "(unsigned char)OffSet=%u\n", (unsigned) OffSet);
     }

  for (row = 0; row < BYTE_SEC; row+=64)

      {
        memcpy (line, index + row, 64);
        for (x = 0; x < 64; x++)
            if (!isprint (line [x])) line [x] = '.';
        printf ("%3u (%02Xh)     %s\n", row, row, line);
      }
}


/*
This routine prints a sectorheader and calls DumpAscii() when _ASC_ is set.
Default it calls DumpHex().
*/

#ifndef ARCHAIC
  void DumpSect (unsigned char NoTrk, unsigned char NoSc)
#else
  void DumpSect (NoTrk, NoSc) unsigned char NoTrk; unsigned char NoSc;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "DumpSect");
        fprintf (stderr, "(unsigned char)NoTrk=%u (unsigned char)NoSc=%u\n",
                 (unsigned) NoTrk, (unsigned) NoSc);
     }

  printf ("\nTrack %u (%02Xh), sector %u (%02Xh)\n\n",
         (unsigned) NoTrk, (unsigned) NoTrk,
         (unsigned) NoSc, (unsigned) NoSc);

  if (_ASC_) DumpAscii (NoSc);
  else DumpHex (NoSc);
}


/*
This routine is used when `od` is called, but it can't do an octal dump. First
it checks whether the required track exists. If it doesn't it exits. Then
SeekTrk() is called to provide the required track. If it fails there seems to
be no point in continuing. Finally, it calls DumpSect() for each sector.
*/

#ifndef ARCHAIC
  void MakeDump (unsigned char DmpTrk)
#else
  void MakeDump (DmpTrk) unsigned char DmpTrk;
#endif

{
  unsigned char MaxTrk = (Tracks * (DSd + 1)) - 1;
  unsigned char Sector;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "MakeDump");
        fprintf (stderr, "(unsigned char)DmpTrk=%u\n", (unsigned) DmpTrk);
     }

  if (DmpTrk > MaxTrk)
     if (CHECK (FATAL))
        ErrMsg (MNOTRACK, ERRSTAT, "MakeDump", (unsigned) DmpTrk, MaxTrk);

  if (SeekTrk (DmpTrk))
     if (CHECK (FATAL))
        ErrMsg (MNOACCES, ERRSTAT, "MakeDump", "Disk", (unsigned) DmpTrk,
               BetaDump);

  for (Sector = 0; Sector < SECT_TRK; Sector++) DumpSect (DmpTrk, Sector);
}


/*
This little goody is just a very simple version of Unix `dc`
*/

#ifndef ARCHAIC
  void MakeCalc (void)
#else
  void MakeCalc ()
#endif

{
  long  i = 0;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "MakeCalc");
        fputs ("NONE\n", stderr);
     }

  for (
        ReadLine ();
        Strnicmp ("quit", LineBuf, strlen (LineBuf) > 0 ? strlen (LineBuf):1);
        ReadLine ()
      ) printf ("%ld\n", i = Strcalc (LineBuf, 1, i));
}


/*
This cute little thing prints the helpscreen and exits.
*/

#ifndef ARCHAIC
  void Help (void)
#else
  void Help ()
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "Help");
        fputs ("NONE\n", stderr);
     }

  puts (HelpText);
  if (_CAL_) exit (1);
}


/*
Reads a listfile, specified by @FILENAME.EXT, which is used by `ls` and `cp`.
Since these are pretty crucial, specifying and and not having one is a fatal
error.
*/

#ifndef DEMO
#ifndef ARCHAIC
  char **GetListFile (char *ListFile)
#else
  char **GetListFile (ListFile) char *ListFile;
#endif

{
  char **args;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "GetListFile");
        fprintf (stderr, "(char*)ListFile=%s\n", ListFile);
     }

  if (!exists (ListFile))
     {
       if (CHECK (FATAL))
          ErrMsg (MNOTHERE, ERRSTAT, "GetListFile", "List", ListFile);
     }
  else
    {
      if ((args = (Fget_va (ListFile, DeLims))) != NULL)
         {
           if (CHECK (DEBUG))
              ErrMsg (MHPALLOC, ERRSTAT, "GetListFile", args, ListFile);
         }                               /* lees INI-file in en verwerk */
      else
        if (CHECK (FATAL))
           ErrMsg (MDATFERR, ERRSTAT, "GetListFile", "read", "list", ListFile);
    }

  return (args);
}
#endif


/*
Reads an init-file and processes it.
*/

#ifndef ARCHAIC
  void GetIniOptions (char *INIfile, char _INI_)
#else
  void GetIniOptions (INIfile, _INI_) char *INIfile; char _INI_;
#endif

{
  char **args;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "GetIniOptions");
        fprintf (stderr, "(char*)INIfile=%s (char)_INI_=%s\n",
                 INIfile, TOBOOL (_INI_));
     }

  if (!exists (INIfile))
     {
       if (CHECK (_INI_ ? DEBUG : ERROR))
          ErrMsg (MNOTHERE, ERRSTAT, "GetIniOptions", "Init", INIfile);
     }
  else
    {
      if ((args = (Fget_va (INIfile, DeLims))) != NULL)
         {
           if (CHECK (DEBUG))
              ErrMsg (MHPALLOC, ERRSTAT, "GetIniOptions", args, INIfile);

           GetOptions (args);

           if (CHECK (DEBUG))
              {
                ErrMsg (MHPFREED, ERRSTAT, "GetIniOptions", args, INIfile);
                ErrLvl = DEBUG;
                ShowSettings ("GetIniOptions", "Current",
                              "after reading init-file");
              }

           free_va (args);
         }                               /* lees INI-file in en verwerk */
      else
        if (CHECK (ERROR))
           ErrMsg (MDATFERR, ERRSTAT, "GetIniOptions", "read", "init", INIfile);
    }
}


/*
This routine sets all indicators, provided the according switches are set.
_SMS_ is only for registered users.
*/

#ifndef ARCHAIC
  void GetOptions (char **args)
#else
  void GetOptions (args) char **args;
#endif

{

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "GetOptions");
        PrintArgs (args, "args");
     }

  for (;((*args) && ((*args)[0] == '-')); args++)

    switch ((*args)[1])
    {
      case 'D': O_DbgLvl = (*args)[2] - '0' > FATAL ? FATAL : (*args)[2]-'0';
                break;
      case 'i': O_InterLeave = ((*args)[2] - '1') & 7;
                _FIL_ = TRUE; break;
      case 's': _FSL_ = (*args)[2] == '-' ? FALSE : TRUE; break;
      case 'u': _SEF_ = (*args)[2] == '-' ? FALSE : TRUE; break;
      case 'f': _FDC_ = (*args)[2] == '-' ? FALSE : TRUE; break;
      case 'l': _LNG_ = (*args)[2] == '-' ? FALSE : TRUE; break;
      case 'c': _ASC_ = (*args)[2] == '-' ? FALSE : TRUE; break;
#ifndef DEMO
      case 'S': _SMS_ = (*args)[2] == '-' ? FALSE : TRUE; break;
#endif
      case 'C': O_ConverType =
                (*args)[2] - '0' > Z80V2 ? Z80V2 : (*args)[2]-'0';
                break;
      case 'M': O_MediaType =
                (*args)[2] - '0' > ANADUMP ? ANADUMP : (*args)[2]-'0';
                break;
      case 'd': O_DataChar   = (char) toupper ((int) (*args)[2]); break;
      case 'I': GetIniOptions ((*args) + 2, FALSE); break;
      case 'F': Strncopy (O_BetaDump, (*args) + 2, sizeof (O_BetaDump)); break;
#ifdef DRDOS
      case 'E': Strncopy (O_Spectrum, (*args) + 2, sizeof (O_Spectrum)); break;
#endif
      case 'p': Strncopy (O_Prompt, (*args) + 2, sizeof (O_Prompt)); break;
      case '#': O_DataType   = NUMBER; break;
      case '$': O_DataType   = STRING; break;
      case 't': O_odTrk      = (unsigned char) atoi ((*args) + 2); break;
      case '?': if (_CAL_) Help (); break;
      case 'V': if (_CAL_) version (__FILE__, 2); break;
      case 'v': if (_CAL_)
                   {
                     ErrLvl = DEBUG;
                     ShowSettings ("GetOptions", "Current", "at \'-v\' option");
                     exit (3);
                   }
                break;
      default : if (CHECK (WARN))
                   ErrMsg (MILLOPT, ERRSTAT, "GetOpts", (*args)[1]);
                break;
    }
}


/*
In this routine BDDE tries to collect the names that make op the filelist. The
very last arguments (`cp`) *must* contain the targetdirectory (like Unix). All
other arguments are used in the filelist.
*/

#ifndef ARCHAIC
  void GetFileList (char **Yargs, int Yargn, char OsCmd)
#else
  void GetFileList (Yargs, Yargn, OsCmd) char **Yargs; int Yargn; char OsCmd;
#endif

{
  char   **args;                       /* argumenten uit verschillende bron */
  char    *p;                          /* temporary pointer */
  char     Source;                     /* source for `cp` command */

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "GetFileList");
        fprintf (stderr, "(char)OsCmd=%u (int)Yargn=%d ",
                (unsigned) OsCmd, Yargn);
        PrintArgs (Yargs, "Yargs");
     }

  if (OsCmd == CP)
     if (exists (Yargs [Yargn - 1]))
        {
          Strtodir (TgtDir, Yargs [Yargn - 1]);
          Yargs [Yargn - 1] = NULL;
        }

     else
       if (CHECK (FATAL))
          ErrMsg (MNO_TDIR, ERRSTAT, "GetAllOptions", Yargs [Yargn - 1]);

  for (;((*Yargs) && ((*Yargs)[0] == '-')); Yargs++);

  if (*Yargs)                          /* Check for '*' or filelist */
     {
       for (
            args = Yargs, Source = FILESPEC;
            (*args) && (Source == FILESPEC);
            args++
           )
           {
             if (!strcmp (*args, "*")) Source = WILDCARD;
#ifndef DEMO
             if ((*args)[0] == '@')
                {
                  Source = LISTFILE;
                  p = (*args) +1;
                }
#endif
           }

       switch (Source)
         {
           case (WILDCARD): FileList = NULL; break;
           case (FILESPEC): FileList = Yargs; break;
#ifndef DEMO
           case (LISTFILE): FileList = GetListFile (p); _FFL_ = TRUE; break;
#endif
         }
     }
}


/*
In this routine the options are collected from various sources; first from
bdde.ini, then from the environment variable $BDDEINIT and finally from the
commandline-options.
*/

#ifndef ARCHAIC
  void GetAllOptions (char **Xargs, int Xargn, char OSCmd, char *BddePath)
#else
  void GetAllOptions (Xargs, Xargn, OSCmd, BddePath) char **Xargs; int Xargn;
       char OSCmd; char *BddePath;
#endif

{
  char   **args;                       /* argumenten uit verschillende bron */
  char    *p;                          /* temporary pointer */
  char     _INI_ = FALSE;              /* reading an bdde.ini file? */

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "GetAllOptions");
        fprintf (stderr, "(char)OSCmd=%u (int)Xargn=%d (char*)BddePath=%s ",
                (unsigned) OSCmd, Xargn, BddePath);
        PrintArgs (Xargs, "Xargs");
     }

  if (CHECK (DEBUG)) ShowSettings ("GetAllOptions", "Default", "at startup");
                                       /* init user charset */
  if (((p = getenv ("BDDE")) != NULL) && (strlen (p) != 0))
     Strtodir (LineBuf, p);
  else
     {
       _INI_ = TRUE;
#ifdef UNIX
       if (((p = getenv ("HOME")) != NULL) && (strlen (p) != 0))
          Strtodir (LineBuf, p);
       else
          {
            strcpy (LineBuf, "");
            if (CHECK (ERROR))
               ErrMsg (MNOHOME, ERRSTAT, "GetAllOptions");
          }
#else
       if (((p = dirname (BddePath)) == NULL) && (CHECK (FATAL)))
          ErrMsg (MHPNOMEM, ERRSTAT, "GetAllOptions", "init-file directory");

       if ((Strncopy (LineBuf, p, sizeof (LineBuf))) == NULL)
          if (CHECK (ERROR))
             ErrMsg (MTOOLONG, ERRSTAT, "GetAllOptions", p);

#ifdef DRDOS
       if ((Strncopy (BddeManPath, LineBuf, sizeof (BddeManPath) -
          strlen (BDDEMAN)) == NULL) && (CHECK (ERROR)))
             ErrMsg (MTOOLONG, ERRSTAT, "GetAllOptions", BDDEMAN);
       else strcat (BddeManPath, BDDEMAN);
#endif

       if (CHECK (DEBUG))
          ErrMsg (MHPALLOC, ERRSTAT, "GetAllOptions", p, "init-file directory");
       if (CHECK (DEBUG))
          ErrMsg (MHPFREED, ERRSTAT, "GetAllOptions", p, "init-file directory");

       free (p);
#endif
     }                                 /* create name of possible INI-file */

  GetIniOptions (strcat (LineBuf, IniFile), _INI_);
                                       /* read INI-file and process */
  if ((p = getenv ("BDDEINIT")) != NULL)
     {
       if (Strncopy (LineBuf, p, sizeof (LineBuf)) == NULL)
          if (CHECK (ERROR))
             ErrMsg (MTOOLONG, ERRSTAT, "GetAllOptions", "$BDDEINIT");

       if (((args = Strtova (LineBuf, " ")) == NULL) && (CHECK (FATAL)))
          ErrMsg (MHPNOMEM, ERRSTAT, "GetAllOptions", "$BDDEINIT");

       if (CHECK (DEBUG))
          ErrMsg (MHPALLOC, ERRSTAT, "GetAllOptions", args, "$BDDEINIT");

       GetOptions (args);

       if (CHECK (DEBUG))
          ErrMsg (MHPFREED, ERRSTAT, "GetAllOptions", args, "$BDDEINIT");
       free (args);                    /* read environment variabele in */
     }

  if (CHECK (DEBUG))
     ShowSettings ("GetAllOptions", "Current", "after $BDDEINIT");

  GetOptions (Xargs);

  GetFileList (Xargs, Xargn, OSCmd);

  if (CHECK (DEBUG))
     ShowSettings ("GetAllOptions", "Current", "after commandline-options");
}


/*
Execute simply selects the elements, which make up a command and then executes
them. What else do you expect?
*/

#ifndef ARCHAIC
  void Execute (char OSCmd)
#else
  void Execute (OSCmd) char OSCmd;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "Execute");
        fprintf (stderr, "(char)OSCmd=%u\n", (unsigned) OSCmd);
     }

  switch (OSCmd)
  {
    case LS: MountDisk (); MakeDir (LS); UnMountDisk (); break;
    case DF: MountDisk (); VolInfo  (TrkBuf + BOOTOFFS); UnMountDisk (); break;
    case DI: MountDisk (); DiskInfo (TrkBuf + BOOTOFFS); UnMountDisk (); break;
    case CP: MountDisk (); MakeCopy (); UnMountDisk (); break;
    case OD: MountDisk (); MakeDump (O_odTrk); UnMountDisk (); break;
    case DC: MakeCalc (); break;
    case SH: if (_CAL_) BddeShell (); break;
  }
}


/*
This routine encodes the command entered, so it can more easily be handled.
LS = 0, DF = 1, DI = 2, CP = 3, OD = 4, DC = 5 and SH = 6. That's all.
*/

#ifndef ARCHAIC
  char GetCommand (char *command)
#else
  char GetCommand (command) char *command;
#endif

{
  static char *Cmd [] = { "ls", "df", "di", "cp", "od", "dc", "sh" };
  char OSCmd;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "GetCommand");
        fprintf (stderr, "(char*)command=%s\n", command);
     }

  if (strlen (command) == 2)
     for (OSCmd = 0; OSCmd < 7; OSCmd++)
       if ((command [0] == Cmd [OSCmd][0]) && (command [1] == Cmd [OSCmd][1]))
          return (OSCmd);

  return (-1);
}


/*
This routine executes the 'mount' command in ExecShell. Note that `mount` does
absolutely nothing except to provide an interface to set options!
*/

#ifndef ARCHAIC
  void ExecMount (char *Argument)
#else
  void ExecMount (Argument) char *Argument;
#endif

{
  char **Qargs;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "ExecMount");
        fprintf (stderr, "(char*)Argument=%s\n", Argument);
     }

  if (strlen (Argument) == 0)
     {
       if (strlen (O_BetaDump) == 0) puts ("Nothing mounted");
       else
         {
           printf ("BetaDisk \'%s\' mounted, interleave %u:1",
                  O_BetaDump, O_InterLeave + 1);

           switch (O_MediaType)
           {
             case (RAWDUMP): puts (", raw dump"); break;
             case (ANADUMP): printf ("%s, Anadisk dump\n",
                                     _FIL_ ? " (fixed)" : " (auto)");
                             break;
           }
         }
       }
  else
    {
      _FIL_ = FALSE;

      if (((Qargs = Strtova (Argument, " ")) == NULL) && (CHECK (FATAL)))
         ErrMsg (MHPNOMEM, ERRSTAT, "ExecShell", "\'mount\' options");

      if (CHECK (DEBUG))
         ErrMsg (MHPALLOC, ERRSTAT, "ExecShell", Qargs, "\'mount\' options");

      GetOptions (Qargs);

      if (CHECK (DEBUG))
         ErrMsg (MHPFREED, ERRSTAT, "ExecShell", Qargs, "\'mount\' options");

      free (Qargs);
    }
}


/*
This command executes all internal shell commands.
*/

#ifndef ARCHAIC
  void ExecShell (char *Comm, char *Argum)
#else
  void ExecShell (Comm, Argum) char *Comm; char *Argum;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "ExecShell");
        fprintf (stderr, "(char*)Comm=%s (char*)Argum=%s\n", Comm, Argum);
     }

  if (!strcmp (Comm, "mount")) ExecMount (Argum);

  else if (!strcmp (Comm, "cd"))
       {
         if (strlen (Argum) != 0)
#ifdef UNIX
            chdir (Argum);
#else
            _chdir (Argum);
#endif
       }
  else if (!strcmp (Comm, "pwd"))
       {
         if (getcwd (LineBuf, sizeof (LineBuf)) != NULL)
            puts (Strlwr (LineBuf));
       }
  else if (!strcmp (Comm, "echo")) puts (Argum);

  else if (!strcmp (Comm, "exit"))
       {
         CleanUp ();
         if (CHECK (INFO)) ErrMsg (MEXIT_SH, ERRSTAT, "ExecShell", Fatals);
         exit (0);
       }
#ifndef DEMO
  else if (!strcmp (Comm, "env"))
       {
         ErrLvl = DEBUG;
         ShowSettings ("ExecShell", "Current", "at \'env\' command");
       }
#endif
#ifndef _Windows
  else if (!strcmp (Comm, "sleep"))
       {
         if (strlen (Argum) != 0) sleep ((unsigned) atoi (Argum));
       }

  else if (!strcmp (Comm, "!")) system (Argum);
#ifdef DRDOS
#ifndef DEMO
  else if (!strcmp (Comm, "zx")) system (O_Spectrum);

  else if (!strcmp (Comm, "guide")) system (BddeManPath);
#endif
#endif
#endif
  else if (!strcmp (Comm, "#"));

  else if (!strcmp (Comm, "man")) puts (ManScreen);

  else if (!strcmp (Comm, "help")) Help ();

  else if (CHECK (WARN)) ErrMsg (MNOCOMMD, ERRSTAT, "ExecShell", Comm);
}


/*
This function sets up the interface between BDDEs commands and the shell. Note
that the shell is *not* reentrant!
*/

#ifndef ARCHAIC
  void ExecCommand (char Command, int PatchPos)
#else
  void ExecCommand (Command, PatchPos) char Command; int PatchPos;
#endif

{
  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "ExecCommand");
        fprintf (stderr, "(char)Command=%u (int)PatchPos=%d\n",
                 (unsigned) Command, PatchPos);
     }

  if (PatchPos > 0) LineBuf [PatchPos] = ' ';

  if (((PendCall = Strtova (LineBuf, " ")) == NULL) && (CHECK (FATAL)))
     ErrMsg (MHPNOMEM, ERRSTAT, "ExecCommand", "internal call");;

  if (CHECK (DEBUG))
     ErrMsg (MHPALLOC, ERRSTAT, "ExecCommand", PendCall, "internal call");

  _FPC_ = TRUE;
                                       /* CleanUp() cleans this malloc() up */
  GetOptions  (PendCall + 1);
  GetFileList (PendCall + 1, (depth_va (PendCall)) - 1, Command);
  Execute (Command);
}


/*
This is the main routine and entry-point for executing the shell.
*/

#ifndef ARCHAIC
  void BddeShell (void)
#else
  void BddeShell ()
#endif

{
  char *Cmd = LineBuf;
  char *Args;
  int  OsCmd;
  int  Patch;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "BddeShell");
        fputs ("NONE\n", stderr);
     }

  _CAL_ = FALSE;                       /* We are now in the shell */

  Fatals = setjmp (ShellErr);          /* Return from error */

  for (;;)
      {
        for (                          /* Display prompt and get command */
              fputs (O_Prompt, stdout);
              strlen (ReadLine()) == 0;
              fputs (O_Prompt, stdout)
            );

        if ((Patch = Strpos (" ", LineBuf, 0)) == -1)
           Args = &(LineBuf [strlen (LineBuf)]);
        else
           {                           /* Patch command and arguments */
             LineBuf [Patch] = '\0';
             Args = &(LineBuf [Patch + 1]);
           }
                                       /* Internal command called */
        if ((OsCmd = GetCommand (Cmd)) != -1) ExecCommand (OsCmd, Patch);
        else ExecShell (Cmd, Args);    /* Probably shell command called */

        CleanUp ();
      }
}


/*
main() does very little. First it finds out which command to call, then it
selects all options and mounts the disk. OsCmd holds the commandcode when
Execute() is called, making it easy to check on later and build decisiontrees.
**argv points to the first thing after the command when GetAllOptions() is
called. It also mounts and unmounts the disk.
*/

#ifndef ARCHAIC
  int main (int argc, char *argv [])
#else
  int main (argc, argv) int argc; char *argv [];
#endif

{
  int OsCmd;

  if (CHECK (FLOW))
     {
        ErrMsg (MARGUMEN, ERRSTAT, "main");
        fprintf (stderr, "(int)argc=%d ", argc);
        PrintArgs (argv, "argv");
     }

  if ((argc < 2) || ((OsCmd = GetCommand (argv [1])) == -1))
#ifndef _Windows
     Help ();
#else
     OsCmd = SH;
#endif

  GetAllOptions (argv + 2, argc - 2, OsCmd, argv [0]);
  Execute (OsCmd);
  return (EXIT_SUCCESS);
}

