/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| DEPTH_VA.C      |Header| HANSOFT         |Library| HANSOFT         |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Turbo C V2.0                                     | HanSoft          |130994|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Made function ANSI-C compliant                   | HanSoft          |260698|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| None                                             |                  |      |
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


Returns the depth of an array, in other words the number of valid (char*) in
list_va up to the first NULL-pointer. list_va *MUST* contain a NULL-pointer!

Prototype: int dept_va (char **list_va)
Returns  : Number of valid char* in list_va or
           -1 if list_va is a NULL-pointer
           The result is undefined if an uninitialized char** is used.
Memory   : None allocated
Example  :

#include <stdio.h>
#include "hansoft.h"

int main (int argc, char **argv)

{
  printf ("depth of this array: %d\n", depth_va (argv));
  return (EXIT_SUCCESS);
}

Input    : 1 2 3
Output   : 4
Related  : fget_va(), fput_va(), strtova(), free_va()

*/


#ifndef ARCHAIC
  int depth_va (char **list)
#else
  int depth_va (list) char **list;
#endif

{
  int x;

  if (list)
     {
       for (x = 0; *list; x++, list++);
       return (x);
     }
  else return (-1);
}
