/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| DIRNAME.C       |Header| HANSOFT         |Library| HANSOFT         |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Turbo C V2.0 version                             | HanSoft          |310390|
| Bull DPX/2 version                               | HanSoft          |240792|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Renamed function to UNIX standard dirname()      | HanSoft          |010591|
| Major bug fixed! Now always returns strslc()     | HanSoft          |250292|
| Added manual page support                        | HanSoft          |210792|
| Made routine portable to Unix                    | HanSoft          |240792|
| Added ANSI_C and CEXT support                    | HanSoft          |280294|
| Made function ANSI-C compliant                   | HanSoft          |240698|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| None                                             |                  |      |
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


Returns a pointer to a string containing the drive and directory information
of a filename, including the last backslash (or NULL if error).
e.g. p = dirname ("a:\dos\command.com")
*/

#ifdef USRLIBHANSOFT
#include <hansoft.h>
#else
#include "hansoft.h"
#endif

#ifdef UNIX
#define _DS_ '/'
#else
#define _DS_ '\\'
#endif


#ifndef ARCHAIC
  char *dirname (char *filename)
#else
  char *dirname (filename) char *filename;
#endif

{
  int y = Strlchr (filename, _DS_);
#ifndef UNIX
  if (y == -1) y = Strlchr (filename, ':');
#endif
  return (Strslc (NULL, filename, 0, y));
}

