/*       hansoft.h

         Definitions for portable C extensions.

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _HANSOFT_H
#define _HANSOFT_H

#ifndef NULL
#ifndef UNIX
#if defined(__TINY__) || defined(__SMALL__) || defined(__MEDIUM__)
#define NULL    0
#else
#define NULL    0L
#endif
#else
#define NULL    0
#endif
#endif

#ifndef ARCHAIC
#define __PROTO(p) p
#else
#define __PROTO(p) ()
#endif

#ifndef UNIX
#define _DS_ '\\'
#else
#define _DS_ '/'
#endif

#if !defined(TRUE) || !defined(FALSE)
#define TRUE    (1)
#define FALSE   (0)
#endif

#ifdef __TURBOC__
#if __STDC__
#define _Cdecl
#else
#define _Cdecl  cdecl
#endif

int     _Cdecl  execsp   (char *Cmdl);
int     _Cdecl  execs    (char *Cmdl);
int     _Cdecl  promptd  (char *prompt, int low, int high);
void    _Cdecl  _perror  (char *Msg);
void    _Cdecl  uperror  (char *Msg, int ERROR);
void    _Cdecl  _uperror (char *Msg, int ERROR);
char   *_Cdecl  dirname  (char *filename);
char   *_Cdecl  basename (char *filename);
char    _Cdecl  endian   (unsigned value);

#else

extern int     execsp   __PROTO ((char *Cmdl));
extern int     execs    __PROTO ((char *Cmdl));
extern int     promptd  __PROTO ((char *prompt, int low, int high));
extern void    _perror  __PROTO ((char *Msg));
extern void    uperror  __PROTO ((char *Msg, int ERROR));
extern void    _uperror __PROTO ((char *Msg, int ERROR));
extern char   *dirname  __PROTO ((char *filename));
extern char   *basename __PROTO ((char *filename));
extern char    endian   __PROTO ((unsigned value));

#endif

#ifdef __TURBOC__
#if !defined(__STDIO_DEF_)
#include <stdio.h>
#endif
#else
#if !defined(_STDIO_H)
#include <stdio.h>
#endif
#endif

typedef struct {
   FILE *TextFile;
   char *Buffer;
   int   BufLen;
   char *Delim;
   int   In;
} TFILE;

#ifdef __TURBOC__
FILE*   _Cdecl  Fopene  (char* name, char* mode);
FILE*   _Cdecl  Fopeneb (char* name, char* mode, void* buf, int size);
int     _Cdecl  Fcloseb (FILE *file, char *buf);
char**  _Cdecl  Fget_va (char *filename, char *delims);
int     _Cdecl  Fput_va (char **char_va, char *filename);
void    _Cdecl  free_va (char **p);
int     _Cdecl  depth_va (char **list);
TFILE*  _Cdecl  Fopent (char* name, char* delim, int size);
char*   _Cdecl  Fgett (char *line, int chars, TFILE *file);
int     _Cdecl  Fcloset (TFILE *file);
int     _Cdecl  Fcopy (FILE* Infile, char *OutName);
char*   _Cdecl  Fload (char *TFname, size_t TFxtra, size_t *TFsize);
char**  _Cdecl  Fgetb_va (char* TFname);
int     _Cdecl  Fputb_va (char **char_va, char *filename);
char**  _Cdecl  Fgets_va (char *filename, char mode);

#else
extern  FILE*   Fopene   __PROTO ((char* name, char* mode));
extern  FILE*   Fopeneb  __PROTO ((char* name, char* mode, void* buf, int size));
extern  int     Fcloseb  __PROTO ((FILE *file, char *buf));
extern  char**  Fget_va  __PROTO ((char *filename, char *delims));
extern  int     Fput_va  __PROTO ((char **char_va, char *filename));
extern  void    free_va  __PROTO ((char **p));
extern  int     depth_va __PROTO ((char **list));
extern  TFILE*  Fopent   __PROTO ((char* name, char* delim, int size));
extern  char*   Fgett    __PROTO ((char *line, int chars, TFILE *file));
extern  int     Fcloset  __PROTO ((TFILE *file));
extern  int     Fcopy    __PROTO ((FILE* Infile, char *OutName));
extern  char*   Fload    __PROTO ((char *TFname, size_t TFxtra, size_t *TFsize));
extern  char**  Fgetb_va __PROTO ((char* TFname));
extern  int     Fputb_va __PROTO ((char **char_va, char *filename));
extern  char**  Fgets_va __PROTO ((char *filename, char mode));

#endif

#ifdef __TURBOC__
int     _Cdecl  Strpos   (char *sub, char *str, int indx);
int     _Cdecl  Stripos  (char *sub, char *str, int indx);
int     _Cdecl  Strsub   (char *sub, char *str);
int     _Cdecl  Strisub  (char *sub, char *str);
char   *_Cdecl  Strins   (char *sub, char *str, int indx);
char   *_Cdecl  Strdel   (char *str, int beg, int last);
char   *_Cdecl  Strslc   (char *str1, char *str2, int beg, int last);
char   *_Cdecl  Strtrm   (char *str);
char   *_Cdecl  Strequ   (char *str);
char   *_Cdecl  Strrpl   (char *str, char *old, char *new);
char   *_Cdecl  Strnrpl  (char *str, int pos, int n, char *new);
char   *_Cdecl  Strfill  (char *buffer, char chr, unsigned int count);
char   *_Cdecl  Strexp   (char *str, unsigned int tab);
int     _Cdecl  Strchrc  (char *str, char *delimit);
int     _Cdecl  Strlchr  (char *str, char chr);
char  **_Cdecl  Strtova  (char *str, char *delimit);
char   *_Cdecl  Strtime  (void);
char   *_Cdecl  Strnfill (char *str, int pos, char filler, int No);
char   *_Cdecl  Strncopy (char *str, char *source, unsigned maxlen);
char   *_Cdecl  Strtodir (char *str, char *dirty);
long    _Cdecl  Strcalc  (char *expression, unsigned NoVars, ...);

#define Strnicmp(a,b,c) strnicmp(a,b,c)
#define Stricmp(a,b) stricmp(a,b)
#define Strlwr(a) strlwr(a)
#define Strupr(a) strupr(a)

#else
extern int     Strpos   __PROTO ((char *sub, char *str, int indx));
extern int     Stripos  __PROTO ((char *sub, char *str, int indx));
extern int     Strsub   __PROTO ((char *sub, char *str));
extern int     Strisub  __PROTO ((char *sub, char *str));
extern char   *Strins   __PROTO ((char *sub, char *str, int indx));
extern char   *Strdel   __PROTO ((char *str, int beg, int last));
extern char   *Strslc   __PROTO ((char *str1, char *str2, int beg, int last));
extern char   *Strtrm   __PROTO ((char *str));
extern char   *Strequ   __PROTO ((char *str));
extern char   *Strrpl   __PROTO ((char *str, char *old, char *new));
extern char   *Strnrpl  __PROTO ((char *str, int pos, int n, char *new));
extern char   *Strfill  __PROTO ((char *buffer, char chr, unsigned int count));
extern char   *Strexp   __PROTO ((char *str, unsigned int tab));
extern int     Strchrc  __PROTO ((char *str, char *delimit));
extern int     Strlchr  __PROTO ((char *str, char chr));
extern char  **Strtova  __PROTO ((char *str, char *delimit));
extern char   *Strtime  __PROTO ((void));
extern char   *Strnfill __PROTO ((char *str, int pos, char filler, int No));
extern char   *Strncopy __PROTO ((char *str, char *source, unsigned maxlen));
extern char   *Strtodir __PROTO ((char *str, char *dirty));
extern long    Strcalc  __PROTO ((char *expression, unsigned NoVars, ...));
extern int     Strnicmp __PROTO ((char *str1, char * str2, int n));
extern int     Stricmp  __PROTO ((char *str1, char * str2));
extern char   *Strlwr   __PROTO ((char *str));
extern char   *Strupr   __PROTO ((char *str));

#endif

#define Strpslc(a,b,c) Strslc(NULL,a,b,c)

#ifdef __TURBOC__
#if !defined(_IO_H)
#include <io.h>
#endif
#else
#if !defined(_UNISTD_H)
#include <unistd.h>
#endif
#endif

#define exists(a) (!(access(a,0)))

#endif
