/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| STRDEL          |Header| HANSOFT         |Library| HANSOFT         |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| MS-Pascal version 1.0d           STR_EXT         | HanSoft          |310387|
| Turbo Pascal V3 version 1.1b     STR_EXT         | HanSoft          |140288|
| Turbo Pascal V4 version 1.2a     MS_STRNG        | HanSoft          |261088|
| Turbo C V1.5 version 1.0b                        | HanSoft          |241188|
| DPX/2 version                                    | HanSoft          |160491|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Split into separate programs                     | HanSoft          |221089|
| Comment translated into English                  | HanSoft          |120491|
| Changed includes to enhance portability          | HanSoft          |160491|
| Added manual page support                        | HanSoft          |210792|
| Added more information to manual page            | HanSoft          |270993|
| Added ANSI_C support                             | HanSoft          |280294|
| Removed EasyC                                    | HanSoft          |100401|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| None                                             |                  |      |
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


Removes all characters between BEG and LAST in STR. Returns pointer to STR
or NULL on error.

Prototype: char *Strdel (char *str, int beg, int last)
Returns  : char pointer to original 'str' when succesful; else NULL
Memory   : None allocated
Example  :

#include <stdio.h>
#include <hansoft.h>

void main (void)

{
  puts (Strdel ("This doesn't work", 9, 11));
}

Input    : None
Output   : This does work
Related  : Strrpl(), Strslc()
Primitive: Yes
*/

#include <stdlib.h>
#include <string.h>


#ifndef ARCHAIC
  char *Strdel (char *str, int beg, int last)
#else
  char *Strdel (str, beg, last) char *str; int beg; int last;
#endif

{
  int x, y, len;

  len = strlen (str);                  /* bereken strlen */

  if (beg > last) return (NULL);       /* check BEG <= LAST */
  if (last > len-1) last = len-1;
  if (beg < 0) beg = 0;                /* check limieten */

  if (len > 0)                         /* skip 0-strings */
    {
      for (x = beg, y = last+1; str[y]; x++, y++) str [x] = str [y];
      str [x] = '\0';                  /* copy characters */
    }

  return (str);
}

