/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| STREQU          |Header| STREXT          |Library| EXTLIB          |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Turbo Pascal V4 version 1.1a                     | HanSoft          |311088|
| Turbo C V1.5 version 1.0a                        | HanSoft          |271188|
| DPX/2 version                                    | HanSoft          |160491|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Split into separate programs                     | HanSoft          |221089|
| Function renamed                                 | HanSoft          |100290|
| Function renamed                                 | HanSoft          |140391|
| Comment translated into English                  | HanSoft          |120491|
| Added manual page support                        | HanSoft          |210792|
| Added CEXT support                               | HanSoft          |240992|
| Added more information to manual page            | HanSoft          |270993|
| Added ANSI_C support; removed CEXT               | HanSoft          |280294|
| Changed to standard C                            | HanSoft          |211098|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| None                                             |                  |      |
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  
Removes leading and trailing spaces in STR and all words are separated by
just one space on return. Returns pointer to STR.

Prototype: char *Strequ (char *str)
Returns  : char pointer to original 'str'
Memory   : None allocated
Example  :

#include <stdio.h>
#include "hansoft.h"
#include <stdlib.h>

int main (void)

{
  puts (Strequ ("  Dir   A:\\c\\str_cpl.c   /W  /p "));
  return (EXIT_SUCCESS);
}

Input    : None
Output   : Dir A:\c\str_cpl.c /W /p
Related  : strtrm()
Primitive: No, Strtrm() and Strdel()
*/

#include <string.h>
#ifdef USRLIBHANSOFT
#include <hansoft.h>
#else
#include "hansoft.h"
#endif


#ifndef ARCHAIC
  char *Strequ (char *str)
#else
  char *Strequ (str) char *str;
#endif

{
  int x, y;

  Strtrm (str);                        /* trim string */

  if (strlen (str) > 0)                /* skip NULL-strings */
     {
       for (x = 0, y = 1; str [y];)
           if ((str [x] == ' ') && (str [y] == ' '))
              Strdel (str, y, y);
           else x = y++;               /* remove superfluous spaces */
     }

  return (str);                        /* return pointer */
}

