/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| STRIPOS         |Header| HANSOFT         |Library| HANSOFT         |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Turbo Pascal V4 version 1.1a     PARSER          | HanSoft          |311088|
| Turbo C V1.5 version 1.0a                        | HanSoft          |271188|
| DPX/2 version                                    | HanSoft          |160491|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Split into separate programs                     | HanSoft          |221089|
| Comment translated into English                  | HanSoft          |120491|
| Added manual page support                        | HanSoft          |210792|
| Added ANSI_C support                             | HanSoft          |280294|
| Removed EasyC                                    | HanSoft          |100401|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| None                                             |                  |      |
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  
Looks for the occurence of SUB in STR from position INDX onward. Case is
ignored. Returns position of SUB when found, otherwise -1.
Usage: pos = Stripos ("OK", "It is okay; that guy is KO", 4)
*/

#include <string.h>
#include <ctype.h>


#ifndef ARCHAIC
  int Stripos (char *sub, char *str, int indx)
#else
  int Stripos (sub, str, indx) char *sub; char *str; int indx;
#endif

{
  int i, j, k;

  if (indx < 0) indx = 0;              /* check of INDX binnen limieten */

  if (indx < strlen (str))
    for (i=indx; str[i]; i++)          /* check bij elk char op substring */
      for (j=i, k=0; toupper (str[j]) == toupper (sub[k]); j++, k++)
        if (! sub [k+1]) return (i);   /* indien elk char gecheckt ret pos */

  return (-1);
}
