/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| STRLWR.C        |Header| HANSOFT         |Library| HANSOFT         |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Bull DPX/2 version                               | HanSoft          |230792|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Added ANSI_C support                             | HanSoft          |280294|
| Removed EasyC                                    | HanSoft          |100401|
| Changed directive to __TURBOC__                  | HanSoft          |070602|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Is available in Turbo C V2.0 (string.h)          | HanSoft          |230792|
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  
Converts all uppercase characters within a string to lowercase.

Prototype: char *Strlwr (char *str)
Returns  : char* to ~str~
Header   : #include <strext.h>
Memory   : None allocated
Example  :

#include <stdio.h>
#include <hansoft.h>

void main (void)

{
 char *str = "This is 1-2-3";

 puts (Strlwr (str));
}

Input    : None
Output   : this is 1-2-3
Relations: Strupr()
*/

#ifndef __TURBOC__
#include <ctype.h>


#ifndef ARCHAIC
  char *Strlwr (char *str)
#else
  char *Strlwr (str) char *str;
#endif

{
  char *p;

  for (p = str; *p; p++) *p = (char) tolower ((int) *p);
  return (str);
}
#endif

