/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| STRNCOPY.C      |Header| HANSOFT         |Library| HANSOFT         |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Turbo C V2.0 version                             | HanSoft          |040693|
| Bull DPX/2 version                               | HanSoft          |040693|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Added ANSI_C support                             | HanSoft          |280294|
| Changed name due to Linux conflict               | HanSoft          |090497|
| Removed EasyC                                    | HanSoft          |100401|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| None                                             |                  |      |
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  
Copies "source" to "str" upto "maxlen"-1 characters

Prototype: char *Strncopy (char *str, char *source, unsigned maxlen)
Returns  : (char *) to str when strlen (source) < maxlen; else NULL
Memory   : None allocated
Example  :

#include <stdio.h>
#include <string.h>
#include <hansoft.h>

void main (void)

{
  char *lstr = "a very long line, this one";
  char *sstr = "a short line";
  char  str [16];

  if (Strncopy (str, lstr, sizeof (str)) == NULL) puts ("(null)");
     else puts (str);

  printf ("%s (%d)\n", str, strlen (str));

  if (Strncopy (str, sstr, sizeof (str)) == NULL) puts ("(null)");
     else puts (str);

  printf ("%s (%d)\n", str, strlen (str));
}

Input    : None
Output   : (null)
           a very long lin (15)
           a short line
           a short line (12)
Related  : strcpy(), strncpy()
*/

#include <stdlib.h>


#ifndef ARCHAIC
  char *Strncopy (char *str, char *source, unsigned maxlen)
#else
  char *Strncopy (str, source, maxlen) char *str; char *source;
       unsigned maxlen;
#endif

{
  unsigned x;

  for (--maxlen, x = 0; (str [x] = source [x]) != '\0'; x++)
      if (x == maxlen)
         {
           str [x] = '\0';
           return (NULL);
         }

  return (str);
}
