/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| STRNICMP.C      |Header| HANSOFT.H       |Library| HANSOFT         |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Berkeley Unix version 4.1 (strncmp.c)            | Berkeley         |211280|
| Bull DPX/2 version        (strnicmp.c)           | HanSoft          |240792|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Added ANSI_C support                             | HanSoft          |280294|
| Removed EasyC                                    | HanSoft          |100401|
| Changed directive to __TUBOC__                   | HanSoft          |070602|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Also available under Turbo C V2 (string.h)       | HanSoft          |240792|
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  
Compare strings non-case sensitive up to the ~n~th byte

Prototype: int Strnicmp (char *str1, char * str2, int n)
Returns  : if ~str1~ > ~str2~ a positive integer
           if ~str1~ = ~str2~ 0
           if ~str1~ < ~str2~ a negative integer
Memory   : none allocated
Example:

#include <stdio.h>

void main (void)

{
  printf ("Result: %d\n", Strnicmp ("straBe", "Strasse", 4));
}

Input  : None
Output : 0
Related: Stricmp(), Strncmp(), strcmp()
*/

#ifndef __TURBOC__
#include <ctype.h>


#ifndef ARCHAIC
  int Strnicmp (char *str1, char *str2, int n)
#else
  int Strnicmp (str1, str2, n) char *str1; char *str2; int n;
#endif

{
  unsigned char *first = (unsigned char*) str1;
  unsigned char *secnd = (unsigned char*) str2;

  if (first == secnd) return (0);

  for (;
       (--n >= 0) && (toupper ((int)*first)) == (toupper ((int)*secnd));
       first++, secnd++
      ) if (*first == '\0') return (0);

  return (n < 0 ? 0 : toupper ((int) *first) - toupper ((int) *secnd));
}
#endif


