/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| STRSLC          |Header| HANSOFT         |Library| HANSOFT         |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| MS-Pascal version 1.0d           STR_EXT         | HanSoft          |310387|
| Turbo Pascal V3 version 1.1b     STR_EXT         | HanSoft          |140288|
| Turbo Pascal V4 version 1.2a     MS_STRNG        | HanSoft          |261088|
| Turbo C V1.5 version 1.0b                        | HanSoft          |241188|
| DPX/2 version                                    | HanSoft          |160491|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Split into separate programs                     | HanSoft          |221089|
| Replaced malloc() by calloc() for portability    | HanSoft          |140391|
| Comment translated into English                  | HanSoft          |120491|
| Changed includes to enhance portability          | HanSoft          |160491|
| Major rewrite; strpslc() is now a macro          | HanSoft          |250291|
| Added manual page support                        | HanSoft          |210792|
| Added more information to manual page            | HanSoft          |270993|
| Added ANSI_C support                             | HanSoft          |280294|
| Made function ANSI-C compliant                   | HanSoft          |260698|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| None                                             |                  |      |
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


Slices STR2 from position BEG to LAST. Returns pointer to the STR1 on succes
and NULL on error. If STR1 is NULL a call to calloc() is made.

Prototype: char *Strslc (char *str1, char *str2, int beg, int last)
Returns  : char pointer when succesful; else NULL
Memory   : None allocated when 'str1' not equals NULL; else length of slice + 1
Example  :

#include <stdio.h>
#include "hansoft.h"

int main (int argc, char **argv)

{
  char  name [16];
  char *slice;

  puts (strslc (name, "Hans is the best", 0, 3));
  puts (slice = Strslc (NULL, "Hans is the best", 12, 15));

  return (EXIT_SUCCESS);
}

Input    : None
Output   : Hans
           best
Related  : Strrpl(), Strdel()
Primitive: Yes
*/

#include <stdlib.h>
#include <string.h>

#ifndef ARCHAIC
  char *Strslc (char *str1, char *str2, int beg, int last)
#else
  char *Strslc (str1, str2, beg, last)
        char *str1; char *str2; int beg; int last;
#endif

{
  int x = 0;                           /* destination counter */
  int y = (beg < 0 ? 0 : beg);         /* source counter */
  int len = strlen (str2);             /* length source */
  char *slice = str1;                  /* pointer to destination */

  if (last < 0) last = -1;             /* check limits */
  if ((len == 0) || (y > last))
     {
       y = 0; last = -1;
     }
                                       /* check str1 and allocate memory */
  if (slice == NULL)
     if ((slice = (char *) calloc ((last - y) + 2, sizeof (char))) == NULL)
        return (NULL);

  for (;y <= last; x++, y++) slice [x] = str2 [y];
  slice [x] = '\0';                    /* copy characters */

  return (slice);
}

