/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| STRTODIR.C      |Header| HANSOFT         |Library| HANSOFT         |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Turbo C V2.0 version                             | HanSoft          |040693|
| Bull DPX/2 version                               | HanSoft          |040693|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Added ANSI_C and CEXT support                    | HanSoft          |280294|
| Removed EasyC                                    | HanSoft          |100401|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Does not check for length of "str"!              | HanSoft          |040693|
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  
Copies a directory-name into "str" and checks that is is _DS_ terminated.

Prototype: char *Strtodir (char *str, char *dirty)
Returns  : (char *) to str
Memory   : None allocated
Example  :

#include <stdio.h>
#include <hansoft.h>

void main (void)

{
  char str1 [16] = "c:\\users9\\c\\";
  char str2 [16] = "c:\\users5\\arj";
  char str3 [16];

  puts (Strtodir (str3, str2));
  puts (Strtodir (str3, str1));
}

Input    : None
Output   : c:\users9\c\
           c:\users5\arj\
Related  : strcpy(), dirname()
*/

#include <string.h>
#ifdef USRLIBHANSOFT
#include <hansoft.h>
#else
#include "hansoft.h"
#endif


#ifndef ARCHAIC
  char *Strtodir (char *str, char *dirty)
#else
  char *Strtodir (str, dirty) char *str; char *dirty;
#endif

{
  int len = strlen (dirty);

  if (strcpy (str, dirty)[--len] != _DS_)
     {
       str [++len] = _DS_; str [++len] = '\0';
     }

  return (str);
}
