/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| STRTRM          |Header| HANSOFT         |Library| HANSOFT         |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| MS-Pascal version 1.0d           STR_EXT         | HanSoft          |310387|
| Turbo Pascal V3 version 1.1b     STR_EXT         | HanSoft          |140288|
| Turbo Pascal V4 version 1.2a     MS_STRNG        | HanSoft          |261088|
| Turbo C V1.5 version 1.0b                        | HanSoft          |241188|
| DPX/2 version                                    | HanSoft          |160491|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Split into separate programs                     | HanSoft          |221089|
| Comments translated into English                 | HanSoft          |120491|
| Added manual page support                        | HanSoft          |210792|
| Added CEXT support                               | HanSoft          |240992|
| Added more information to manual page            | HanSoft          |270993|
| Added ANSI_C support                             | HanSoft          |280294|
| Changed to standard C                            | HanSoft          |211098|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| None                                             |                  |      |
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  
Removes leading and trailing spaces from STR. Returns pointer to STR on
success and NULL on error.
Usage: Strtrm ("    This will be trimmed    ");

Prototype: char *Strtrm (char *str)
Returns  : char pointer to original 'str'
Memory   : None allocated
Example  :

#include <stdio.h>
#include "hansoft.h"
#include <stdlib.h>

int main (void)

{
  puts (Strtrm ("    This will be trimmed    "));
  return (EXIT_SUCCESS);
}

Input    : None
Output   : This will be trimmed
Related  : Strequ(), Strdel(), Strslc()
Primitive: No, Strslc()
*/

#ifdef USRLIBHANSOFT
#include <hansoft.h>
#else
#include "hansoft.h"
#endif
#include <string.h>


#ifndef ARCHAIC
  char *Strtrm (char *str)
#else
  char *Strtrm (str) char *str;
#endif

{
  int x,y;

  if (strlen (str) == 0) return (str); /* return NULL string */

  for (x = 0; str[x] == ' '; x++);     /* get first and last character */
  for (y = strlen (str) - 1; str[y] == ' '; y--);
  if (y < x) return (strcpy (str, ""));
                                       /* return NULL string if all spaces */
  return (Strslc (str, str, x, y));    /* slice from first till last char */
}

