/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| VERSION.C       |Module| N/A             |Library| N/A             |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Turbo C V2.0 version                             | HanSoft          |220592|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Added ANSI_C and __COHERENT__ support            | HanSoft          |090394|
| Added __linux__ support                          | HanSoft          |140401|
| Added __DJGPP__, __LCC__ and __GNUC__ support    | HanSoft          |070602|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| None                                             |                  |      |
+--------------------------------------------------+------------------+------+

  Copyright (C) 1991,2002 J.L. Bezemer

  This file is part of BDDE

  BDDE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


This program has to be #included after stdio.h and stdlib.h have been included.
It shows some important data about the program (compiler, source-file,
compilation-date, model, etc.).
It exists the program (yes, NOT the function) with error-code __stat__. If you
want to use the source-code report use __FILE__ as argument for __main__. If
you want to use the Unix report you have to #define UNIX somewhere.
Since these data are collected during compilation it makes no sense to place it
in a library.

Usage: version (__FILE__, EZERO)
*/


#ifndef ARCHAIC
  void version (char *__main__, int __stat__)
#else
  void version (__main__, __stat__) char *__main__; int __stat__;
#endif

{
#ifdef __TURBOC__
#if   defined (__TINY__)
#define __MODEL__ "tiny"
#elif defined (__SMALL__)
#define __MODEL__ "small"
#elif defined (__COMPACT__)
#define __MODEL__ "compact"
#elif defined (__MEDIUM__)
#define __MODEL__ "medium"
#elif defined (__LARGE__)
#define __MODEL__ "large"
#elif defined (__HUGE__)
#define __MODEL__ "huge"
#endif
#endif

  printf ("\nProgram %s was compiled at %s on %s.\n", __main__,
           __TIME__, __DATE__);
#if defined (__TURBOC__)
  printf ("The Turbo C V%X compiler was used, %s memory model.\n",
          __TURBOC__, __MODEL__);
#elif defined (__LCC__)
  printf ("The LCC-Win32 compiler was used.\n");
#elif defined (__DJGPP__)
  printf ("The DJGPP compiler was used.\n");
#elif defined (__GNUC__)
  printf ("The GCC compiler was used.\n");
#elif defined (__linux__)
  printf ("Some Linux C compiler was used.\n");
#elif defined (__COHERENT__)
  printf ("Some COHERENT C compiler was used.\n");
#elif defined (UNIX)
  printf ("Some UNIX C compiler was used.\n");
#elif defined (_Windows)
  printf ("Some Windows compiler was used.\n");
#elif defined (_WIN32)
  printf ("Some Windows 32-bit compiler was used.\n");
#endif
  exit (__stat__);
}
